// components/attribution_reporting/registration.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_ATTRIBUTION_REPORTING_REGISTRATION_MOJOM_BLINK_H_
#define COMPONENTS_ATTRIBUTION_REPORTING_REGISTRATION_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "components/attribution_reporting/registration.mojom-shared.h"
#include "components/attribution_reporting/registration.mojom-blink-forward.h"
#include "components/aggregation_service/aggregation_service.mojom-blink-forward.h"
#include "mojo/public/mojom/base/int128.mojom-blink.h"
#include "mojo/public/mojom/base/time.mojom-blink.h"
#include "services/network/public/mojom/schemeful_site.mojom-blink.h"
#include "url/mojom/origin.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"




#include "components/attribution_reporting/registration_mojom_traits.h"
#include "third_party/blink/renderer/platform/platform_export.h"




namespace attribution_reporting {
namespace mojom {
namespace blink {





class PLATFORM_EXPORT DebugKey {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DebugKey, T>::value>;
  using DataView = DebugKeyDataView;
  using Data_ = internal::DebugKey_Data;

  template <typename... Args>
  static DebugKeyPtr New(Args&&... args) {
    return DebugKeyPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DebugKeyPtr From(const U& u) {
    return mojo::TypeConverter<DebugKeyPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DebugKey>::Convert(*this);
  }


  DebugKey();

  explicit DebugKey(
      uint64_t value);


  ~DebugKey();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DebugKeyPtr>
  DebugKeyPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DebugKey::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, DebugKey::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DebugKey::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DebugKey::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DebugKey_UnserializedMessageContext<
            UserType, DebugKey::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<DebugKey::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return DebugKey::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DebugKey_UnserializedMessageContext<
            UserType, DebugKey::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DebugKey::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t value;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DebugKey::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DebugKey::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DebugKey::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DebugKey::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}












class PLATFORM_EXPORT TriggerDedupKey {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<TriggerDedupKey, T>::value>;
  using DataView = TriggerDedupKeyDataView;
  using Data_ = internal::TriggerDedupKey_Data;

  template <typename... Args>
  static TriggerDedupKeyPtr New(Args&&... args) {
    return TriggerDedupKeyPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TriggerDedupKeyPtr From(const U& u) {
    return mojo::TypeConverter<TriggerDedupKeyPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TriggerDedupKey>::Convert(*this);
  }


  TriggerDedupKey();

  explicit TriggerDedupKey(
      uint64_t value);


  ~TriggerDedupKey();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TriggerDedupKeyPtr>
  TriggerDedupKeyPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, TriggerDedupKey::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, TriggerDedupKey::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        TriggerDedupKey::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TriggerDedupKey::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::TriggerDedupKey_UnserializedMessageContext<
            UserType, TriggerDedupKey::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<TriggerDedupKey::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return TriggerDedupKey::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::TriggerDedupKey_UnserializedMessageContext<
            UserType, TriggerDedupKey::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<TriggerDedupKey::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t value;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, TriggerDedupKey::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, TriggerDedupKey::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, TriggerDedupKey::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, TriggerDedupKey::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}











class PLATFORM_EXPORT SuitableOrigin {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SuitableOrigin, T>::value>;
  using DataView = SuitableOriginDataView;
  using Data_ = internal::SuitableOrigin_Data;

  template <typename... Args>
  static SuitableOriginPtr New(Args&&... args) {
    return SuitableOriginPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SuitableOriginPtr From(const U& u) {
    return mojo::TypeConverter<SuitableOriginPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SuitableOrigin>::Convert(*this);
  }


  SuitableOrigin();

  explicit SuitableOrigin(
      const ::scoped_refptr<const ::blink::SecurityOrigin>& origin);


  ~SuitableOrigin();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SuitableOriginPtr>
  SuitableOriginPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SuitableOrigin::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, SuitableOrigin::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SuitableOrigin::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SuitableOrigin::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SuitableOrigin_UnserializedMessageContext<
            UserType, SuitableOrigin::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<SuitableOrigin::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return SuitableOrigin::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SuitableOrigin_UnserializedMessageContext<
            UserType, SuitableOrigin::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SuitableOrigin::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::scoped_refptr<const ::blink::SecurityOrigin> origin;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SuitableOrigin::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SuitableOrigin::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SuitableOrigin::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SuitableOrigin::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class PLATFORM_EXPORT FilterData {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FilterData, T>::value>;
  using DataView = FilterDataDataView;
  using Data_ = internal::FilterData_Data;

  template <typename... Args>
  static FilterDataPtr New(Args&&... args) {
    return FilterDataPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FilterDataPtr From(const U& u) {
    return mojo::TypeConverter<FilterDataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FilterData>::Convert(*this);
  }


  FilterData();

  explicit FilterData(
      const WTF::HashMap<WTF::String, WTF::Vector<WTF::String>>& filter_values);


  ~FilterData();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FilterDataPtr>
  FilterDataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FilterData::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, FilterData::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FilterData::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FilterData::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FilterData_UnserializedMessageContext<
            UserType, FilterData::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<FilterData::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return FilterData::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FilterData_UnserializedMessageContext<
            UserType, FilterData::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FilterData::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::HashMap<WTF::String, WTF::Vector<WTF::String>> filter_values;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FilterData::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FilterData::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FilterData::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FilterData::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class PLATFORM_EXPORT Filters {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Filters, T>::value>;
  using DataView = FiltersDataView;
  using Data_ = internal::Filters_Data;

  template <typename... Args>
  static FiltersPtr New(Args&&... args) {
    return FiltersPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FiltersPtr From(const U& u) {
    return mojo::TypeConverter<FiltersPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Filters>::Convert(*this);
  }


  Filters();

  explicit Filters(
      const WTF::HashMap<WTF::String, WTF::Vector<WTF::String>>& filter_values);


  ~Filters();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FiltersPtr>
  FiltersPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Filters::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Filters::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Filters::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Filters::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Filters_UnserializedMessageContext<
            UserType, Filters::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Filters::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Filters::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Filters_UnserializedMessageContext<
            UserType, Filters::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Filters::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::HashMap<WTF::String, WTF::Vector<WTF::String>> filter_values;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Filters::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Filters::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Filters::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Filters::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class PLATFORM_EXPORT FilterPair {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FilterPair, T>::value>;
  using DataView = FilterPairDataView;
  using Data_ = internal::FilterPair_Data;

  template <typename... Args>
  static FilterPairPtr New(Args&&... args) {
    return FilterPairPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FilterPairPtr From(const U& u) {
    return mojo::TypeConverter<FilterPairPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FilterPair>::Convert(*this);
  }


  FilterPair();

  FilterPair(
      const ::attribution_reporting::Filters& positive,
      const ::attribution_reporting::Filters& negative);


  ~FilterPair();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FilterPairPtr>
  FilterPairPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FilterPair::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, FilterPair::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FilterPair::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FilterPair::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FilterPair_UnserializedMessageContext<
            UserType, FilterPair::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<FilterPair::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return FilterPair::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FilterPair_UnserializedMessageContext<
            UserType, FilterPair::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FilterPair::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::attribution_reporting::Filters positive;
  
  ::attribution_reporting::Filters negative;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FilterPair::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FilterPair::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FilterPair::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FilterPair::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class PLATFORM_EXPORT AggregationKeys {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AggregationKeys, T>::value>;
  using DataView = AggregationKeysDataView;
  using Data_ = internal::AggregationKeys_Data;

  template <typename... Args>
  static AggregationKeysPtr New(Args&&... args) {
    return AggregationKeysPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AggregationKeysPtr From(const U& u) {
    return mojo::TypeConverter<AggregationKeysPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AggregationKeys>::Convert(*this);
  }


  AggregationKeys();

  explicit AggregationKeys(
      const WTF::HashMap<WTF::String, ::absl::uint128>& keys);


  ~AggregationKeys();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AggregationKeysPtr>
  AggregationKeysPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AggregationKeys::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AggregationKeys::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AggregationKeys::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AggregationKeys::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AggregationKeys_UnserializedMessageContext<
            UserType, AggregationKeys::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AggregationKeys::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return AggregationKeys::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AggregationKeys_UnserializedMessageContext<
            UserType, AggregationKeys::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AggregationKeys::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::HashMap<WTF::String, ::absl::uint128> keys;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AggregationKeys::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AggregationKeys::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AggregationKeys::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AggregationKeys::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class PLATFORM_EXPORT AggregatableTriggerData {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AggregatableTriggerData, T>::value>;
  using DataView = AggregatableTriggerDataDataView;
  using Data_ = internal::AggregatableTriggerData_Data;

  template <typename... Args>
  static AggregatableTriggerDataPtr New(Args&&... args) {
    return AggregatableTriggerDataPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AggregatableTriggerDataPtr From(const U& u) {
    return mojo::TypeConverter<AggregatableTriggerDataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AggregatableTriggerData>::Convert(*this);
  }


  AggregatableTriggerData();

  AggregatableTriggerData(
      const ::absl::uint128& key_piece,
      WTF::Vector<WTF::String> source_keys,
      const ::attribution_reporting::FilterPair& filters);


  ~AggregatableTriggerData();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AggregatableTriggerDataPtr>
  AggregatableTriggerDataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AggregatableTriggerData::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AggregatableTriggerData::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AggregatableTriggerData::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AggregatableTriggerData::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AggregatableTriggerData_UnserializedMessageContext<
            UserType, AggregatableTriggerData::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AggregatableTriggerData::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return AggregatableTriggerData::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AggregatableTriggerData_UnserializedMessageContext<
            UserType, AggregatableTriggerData::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AggregatableTriggerData::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::absl::uint128 key_piece;
  
  WTF::Vector<WTF::String> source_keys;
  
  ::attribution_reporting::FilterPair filters;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AggregatableTriggerData::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AggregatableTriggerData::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AggregatableTriggerData::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AggregatableTriggerData::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class PLATFORM_EXPORT SourceRegistration {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SourceRegistration, T>::value>;
  using DataView = SourceRegistrationDataView;
  using Data_ = internal::SourceRegistration_Data;

  template <typename... Args>
  static SourceRegistrationPtr New(Args&&... args) {
    return SourceRegistrationPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SourceRegistrationPtr From(const U& u) {
    return mojo::TypeConverter<SourceRegistrationPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SourceRegistration>::Convert(*this);
  }


  SourceRegistration();

  SourceRegistration(
      WTF::Vector<::blink::BlinkSchemefulSite> destinations,
      uint64_t source_event_id,
      absl::optional<::base::TimeDelta> expiry,
      absl::optional<::base::TimeDelta> event_report_window,
      absl::optional<::base::TimeDelta> aggregatable_report_window,
      int64_t priority,
      const absl::optional<uint64_t>& debug_key,
      const ::attribution_reporting::FilterData& filter_data,
      const ::attribution_reporting::AggregationKeys& aggregation_keys,
      bool debug_reporting);


  ~SourceRegistration();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SourceRegistrationPtr>
  SourceRegistrationPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SourceRegistration::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, SourceRegistration::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SourceRegistration::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SourceRegistration::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SourceRegistration_UnserializedMessageContext<
            UserType, SourceRegistration::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<SourceRegistration::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return SourceRegistration::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SourceRegistration_UnserializedMessageContext<
            UserType, SourceRegistration::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SourceRegistration::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::Vector<::blink::BlinkSchemefulSite> destinations;
  
  uint64_t source_event_id;
  
  absl::optional<::base::TimeDelta> expiry;
  
  absl::optional<::base::TimeDelta> event_report_window;
  
  absl::optional<::base::TimeDelta> aggregatable_report_window;
  
  int64_t priority;
  
  absl::optional<uint64_t> debug_key;
  
  ::attribution_reporting::FilterData filter_data;
  
  ::attribution_reporting::AggregationKeys aggregation_keys;
  
  bool debug_reporting;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SourceRegistration::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SourceRegistration::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SourceRegistration::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SourceRegistration::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class PLATFORM_EXPORT EventTriggerData {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<EventTriggerData, T>::value>;
  using DataView = EventTriggerDataDataView;
  using Data_ = internal::EventTriggerData_Data;

  template <typename... Args>
  static EventTriggerDataPtr New(Args&&... args) {
    return EventTriggerDataPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static EventTriggerDataPtr From(const U& u) {
    return mojo::TypeConverter<EventTriggerDataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, EventTriggerData>::Convert(*this);
  }


  EventTriggerData();

  EventTriggerData(
      uint64_t data,
      int64_t priority,
      const absl::optional<uint64_t>& dedup_key,
      const ::attribution_reporting::FilterPair& filters);


  ~EventTriggerData();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = EventTriggerDataPtr>
  EventTriggerDataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, EventTriggerData::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, EventTriggerData::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        EventTriggerData::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        EventTriggerData::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::EventTriggerData_UnserializedMessageContext<
            UserType, EventTriggerData::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<EventTriggerData::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return EventTriggerData::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::EventTriggerData_UnserializedMessageContext<
            UserType, EventTriggerData::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<EventTriggerData::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t data;
  
  int64_t priority;
  
  absl::optional<uint64_t> dedup_key;
  
  ::attribution_reporting::FilterPair filters;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, EventTriggerData::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, EventTriggerData::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, EventTriggerData::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, EventTriggerData::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class PLATFORM_EXPORT AggregatableDedupKey {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AggregatableDedupKey, T>::value>;
  using DataView = AggregatableDedupKeyDataView;
  using Data_ = internal::AggregatableDedupKey_Data;

  template <typename... Args>
  static AggregatableDedupKeyPtr New(Args&&... args) {
    return AggregatableDedupKeyPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AggregatableDedupKeyPtr From(const U& u) {
    return mojo::TypeConverter<AggregatableDedupKeyPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AggregatableDedupKey>::Convert(*this);
  }


  AggregatableDedupKey();

  AggregatableDedupKey(
      const absl::optional<uint64_t>& dedup_key,
      const ::attribution_reporting::FilterPair& filters);


  ~AggregatableDedupKey();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AggregatableDedupKeyPtr>
  AggregatableDedupKeyPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AggregatableDedupKey::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AggregatableDedupKey::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AggregatableDedupKey::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AggregatableDedupKey::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AggregatableDedupKey_UnserializedMessageContext<
            UserType, AggregatableDedupKey::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AggregatableDedupKey::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return AggregatableDedupKey::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AggregatableDedupKey_UnserializedMessageContext<
            UserType, AggregatableDedupKey::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AggregatableDedupKey::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  absl::optional<uint64_t> dedup_key;
  
  ::attribution_reporting::FilterPair filters;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AggregatableDedupKey::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AggregatableDedupKey::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AggregatableDedupKey::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AggregatableDedupKey::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class PLATFORM_EXPORT TriggerRegistration {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<TriggerRegistration, T>::value>;
  using DataView = TriggerRegistrationDataView;
  using Data_ = internal::TriggerRegistration_Data;

  template <typename... Args>
  static TriggerRegistrationPtr New(Args&&... args) {
    return TriggerRegistrationPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TriggerRegistrationPtr From(const U& u) {
    return mojo::TypeConverter<TriggerRegistrationPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TriggerRegistration>::Convert(*this);
  }


  TriggerRegistration();

  TriggerRegistration(
      WTF::Vector<::attribution_reporting::EventTriggerData> event_triggers,
      const ::attribution_reporting::FilterPair& filters,
      WTF::Vector<::attribution_reporting::AggregatableTriggerData> aggregatable_trigger_data,
      const WTF::HashMap<WTF::String, uint32_t>& aggregatable_values,
      const absl::optional<uint64_t>& debug_key,
      WTF::Vector<::attribution_reporting::AggregatableDedupKey> aggregatable_dedup_keys,
      bool debug_reporting,
      ::aggregation_service::mojom::blink::AggregationCoordinator aggregation_coordinator);


  ~TriggerRegistration();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TriggerRegistrationPtr>
  TriggerRegistrationPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, TriggerRegistration::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, TriggerRegistration::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        TriggerRegistration::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TriggerRegistration::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::TriggerRegistration_UnserializedMessageContext<
            UserType, TriggerRegistration::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<TriggerRegistration::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return TriggerRegistration::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::TriggerRegistration_UnserializedMessageContext<
            UserType, TriggerRegistration::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<TriggerRegistration::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::Vector<::attribution_reporting::EventTriggerData> event_triggers;
  
  ::attribution_reporting::FilterPair filters;
  
  WTF::Vector<::attribution_reporting::AggregatableTriggerData> aggregatable_trigger_data;
  
  WTF::HashMap<WTF::String, uint32_t> aggregatable_values;
  
  absl::optional<uint64_t> debug_key;
  
  WTF::Vector<::attribution_reporting::AggregatableDedupKey> aggregatable_dedup_keys;
  
  bool debug_reporting;
  
  ::aggregation_service::mojom::blink::AggregationCoordinator aggregation_coordinator;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, TriggerRegistration::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, TriggerRegistration::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, TriggerRegistration::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, TriggerRegistration::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
DebugKeyPtr DebugKey::Clone() const {
  return New(
      mojo::Clone(value)
  );
}

template <typename T, DebugKey::EnableIfSame<T>*>
bool DebugKey::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  return true;
}

template <typename T, DebugKey::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.value < rhs.value)
    return true;
  if (rhs.value < lhs.value)
    return false;
  return false;
}
template <typename StructPtrType>
SuitableOriginPtr SuitableOrigin::Clone() const {
  return New(
      mojo::Clone(origin)
  );
}

template <typename T, SuitableOrigin::EnableIfSame<T>*>
bool SuitableOrigin::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->origin, other_struct.origin))
    return false;
  return true;
}

template <typename T, SuitableOrigin::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.origin < rhs.origin)
    return true;
  if (rhs.origin < lhs.origin)
    return false;
  return false;
}
template <typename StructPtrType>
FilterDataPtr FilterData::Clone() const {
  return New(
      mojo::Clone(filter_values)
  );
}

template <typename T, FilterData::EnableIfSame<T>*>
bool FilterData::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->filter_values, other_struct.filter_values))
    return false;
  return true;
}

template <typename T, FilterData::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.filter_values < rhs.filter_values)
    return true;
  if (rhs.filter_values < lhs.filter_values)
    return false;
  return false;
}
template <typename StructPtrType>
FiltersPtr Filters::Clone() const {
  return New(
      mojo::Clone(filter_values)
  );
}

template <typename T, Filters::EnableIfSame<T>*>
bool Filters::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->filter_values, other_struct.filter_values))
    return false;
  return true;
}

template <typename T, Filters::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.filter_values < rhs.filter_values)
    return true;
  if (rhs.filter_values < lhs.filter_values)
    return false;
  return false;
}
template <typename StructPtrType>
FilterPairPtr FilterPair::Clone() const {
  return New(
      mojo::Clone(positive),
      mojo::Clone(negative)
  );
}

template <typename T, FilterPair::EnableIfSame<T>*>
bool FilterPair::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->positive, other_struct.positive))
    return false;
  if (!mojo::Equals(this->negative, other_struct.negative))
    return false;
  return true;
}

template <typename T, FilterPair::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.positive < rhs.positive)
    return true;
  if (rhs.positive < lhs.positive)
    return false;
  if (lhs.negative < rhs.negative)
    return true;
  if (rhs.negative < lhs.negative)
    return false;
  return false;
}
template <typename StructPtrType>
AggregationKeysPtr AggregationKeys::Clone() const {
  return New(
      mojo::Clone(keys)
  );
}

template <typename T, AggregationKeys::EnableIfSame<T>*>
bool AggregationKeys::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->keys, other_struct.keys))
    return false;
  return true;
}

template <typename T, AggregationKeys::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.keys < rhs.keys)
    return true;
  if (rhs.keys < lhs.keys)
    return false;
  return false;
}
template <typename StructPtrType>
AggregatableTriggerDataPtr AggregatableTriggerData::Clone() const {
  return New(
      mojo::Clone(key_piece),
      mojo::Clone(source_keys),
      mojo::Clone(filters)
  );
}

template <typename T, AggregatableTriggerData::EnableIfSame<T>*>
bool AggregatableTriggerData::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->key_piece, other_struct.key_piece))
    return false;
  if (!mojo::Equals(this->source_keys, other_struct.source_keys))
    return false;
  if (!mojo::Equals(this->filters, other_struct.filters))
    return false;
  return true;
}

template <typename T, AggregatableTriggerData::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.key_piece < rhs.key_piece)
    return true;
  if (rhs.key_piece < lhs.key_piece)
    return false;
  if (lhs.source_keys < rhs.source_keys)
    return true;
  if (rhs.source_keys < lhs.source_keys)
    return false;
  if (lhs.filters < rhs.filters)
    return true;
  if (rhs.filters < lhs.filters)
    return false;
  return false;
}
template <typename StructPtrType>
SourceRegistrationPtr SourceRegistration::Clone() const {
  return New(
      mojo::Clone(destinations),
      mojo::Clone(source_event_id),
      mojo::Clone(expiry),
      mojo::Clone(event_report_window),
      mojo::Clone(aggregatable_report_window),
      mojo::Clone(priority),
      mojo::Clone(debug_key),
      mojo::Clone(filter_data),
      mojo::Clone(aggregation_keys),
      mojo::Clone(debug_reporting)
  );
}

template <typename T, SourceRegistration::EnableIfSame<T>*>
bool SourceRegistration::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->destinations, other_struct.destinations))
    return false;
  if (!mojo::Equals(this->source_event_id, other_struct.source_event_id))
    return false;
  if (!mojo::Equals(this->expiry, other_struct.expiry))
    return false;
  if (!mojo::Equals(this->event_report_window, other_struct.event_report_window))
    return false;
  if (!mojo::Equals(this->aggregatable_report_window, other_struct.aggregatable_report_window))
    return false;
  if (!mojo::Equals(this->priority, other_struct.priority))
    return false;
  if (!mojo::Equals(this->debug_key, other_struct.debug_key))
    return false;
  if (!mojo::Equals(this->filter_data, other_struct.filter_data))
    return false;
  if (!mojo::Equals(this->aggregation_keys, other_struct.aggregation_keys))
    return false;
  if (!mojo::Equals(this->debug_reporting, other_struct.debug_reporting))
    return false;
  return true;
}

template <typename T, SourceRegistration::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.destinations < rhs.destinations)
    return true;
  if (rhs.destinations < lhs.destinations)
    return false;
  if (lhs.source_event_id < rhs.source_event_id)
    return true;
  if (rhs.source_event_id < lhs.source_event_id)
    return false;
  if (lhs.expiry < rhs.expiry)
    return true;
  if (rhs.expiry < lhs.expiry)
    return false;
  if (lhs.event_report_window < rhs.event_report_window)
    return true;
  if (rhs.event_report_window < lhs.event_report_window)
    return false;
  if (lhs.aggregatable_report_window < rhs.aggregatable_report_window)
    return true;
  if (rhs.aggregatable_report_window < lhs.aggregatable_report_window)
    return false;
  if (lhs.priority < rhs.priority)
    return true;
  if (rhs.priority < lhs.priority)
    return false;
  if (lhs.debug_key < rhs.debug_key)
    return true;
  if (rhs.debug_key < lhs.debug_key)
    return false;
  if (lhs.filter_data < rhs.filter_data)
    return true;
  if (rhs.filter_data < lhs.filter_data)
    return false;
  if (lhs.aggregation_keys < rhs.aggregation_keys)
    return true;
  if (rhs.aggregation_keys < lhs.aggregation_keys)
    return false;
  if (lhs.debug_reporting < rhs.debug_reporting)
    return true;
  if (rhs.debug_reporting < lhs.debug_reporting)
    return false;
  return false;
}
template <typename StructPtrType>
TriggerDedupKeyPtr TriggerDedupKey::Clone() const {
  return New(
      mojo::Clone(value)
  );
}

template <typename T, TriggerDedupKey::EnableIfSame<T>*>
bool TriggerDedupKey::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  return true;
}

template <typename T, TriggerDedupKey::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.value < rhs.value)
    return true;
  if (rhs.value < lhs.value)
    return false;
  return false;
}
template <typename StructPtrType>
EventTriggerDataPtr EventTriggerData::Clone() const {
  return New(
      mojo::Clone(data),
      mojo::Clone(priority),
      mojo::Clone(dedup_key),
      mojo::Clone(filters)
  );
}

template <typename T, EventTriggerData::EnableIfSame<T>*>
bool EventTriggerData::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->data, other_struct.data))
    return false;
  if (!mojo::Equals(this->priority, other_struct.priority))
    return false;
  if (!mojo::Equals(this->dedup_key, other_struct.dedup_key))
    return false;
  if (!mojo::Equals(this->filters, other_struct.filters))
    return false;
  return true;
}

template <typename T, EventTriggerData::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.data < rhs.data)
    return true;
  if (rhs.data < lhs.data)
    return false;
  if (lhs.priority < rhs.priority)
    return true;
  if (rhs.priority < lhs.priority)
    return false;
  if (lhs.dedup_key < rhs.dedup_key)
    return true;
  if (rhs.dedup_key < lhs.dedup_key)
    return false;
  if (lhs.filters < rhs.filters)
    return true;
  if (rhs.filters < lhs.filters)
    return false;
  return false;
}
template <typename StructPtrType>
AggregatableDedupKeyPtr AggregatableDedupKey::Clone() const {
  return New(
      mojo::Clone(dedup_key),
      mojo::Clone(filters)
  );
}

template <typename T, AggregatableDedupKey::EnableIfSame<T>*>
bool AggregatableDedupKey::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->dedup_key, other_struct.dedup_key))
    return false;
  if (!mojo::Equals(this->filters, other_struct.filters))
    return false;
  return true;
}

template <typename T, AggregatableDedupKey::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.dedup_key < rhs.dedup_key)
    return true;
  if (rhs.dedup_key < lhs.dedup_key)
    return false;
  if (lhs.filters < rhs.filters)
    return true;
  if (rhs.filters < lhs.filters)
    return false;
  return false;
}
template <typename StructPtrType>
TriggerRegistrationPtr TriggerRegistration::Clone() const {
  return New(
      mojo::Clone(event_triggers),
      mojo::Clone(filters),
      mojo::Clone(aggregatable_trigger_data),
      mojo::Clone(aggregatable_values),
      mojo::Clone(debug_key),
      mojo::Clone(aggregatable_dedup_keys),
      mojo::Clone(debug_reporting),
      mojo::Clone(aggregation_coordinator)
  );
}

template <typename T, TriggerRegistration::EnableIfSame<T>*>
bool TriggerRegistration::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->event_triggers, other_struct.event_triggers))
    return false;
  if (!mojo::Equals(this->filters, other_struct.filters))
    return false;
  if (!mojo::Equals(this->aggregatable_trigger_data, other_struct.aggregatable_trigger_data))
    return false;
  if (!mojo::Equals(this->aggregatable_values, other_struct.aggregatable_values))
    return false;
  if (!mojo::Equals(this->debug_key, other_struct.debug_key))
    return false;
  if (!mojo::Equals(this->aggregatable_dedup_keys, other_struct.aggregatable_dedup_keys))
    return false;
  if (!mojo::Equals(this->debug_reporting, other_struct.debug_reporting))
    return false;
  if (!mojo::Equals(this->aggregation_coordinator, other_struct.aggregation_coordinator))
    return false;
  return true;
}

template <typename T, TriggerRegistration::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.event_triggers < rhs.event_triggers)
    return true;
  if (rhs.event_triggers < lhs.event_triggers)
    return false;
  if (lhs.filters < rhs.filters)
    return true;
  if (rhs.filters < lhs.filters)
    return false;
  if (lhs.aggregatable_trigger_data < rhs.aggregatable_trigger_data)
    return true;
  if (rhs.aggregatable_trigger_data < lhs.aggregatable_trigger_data)
    return false;
  if (lhs.aggregatable_values < rhs.aggregatable_values)
    return true;
  if (rhs.aggregatable_values < lhs.aggregatable_values)
    return false;
  if (lhs.debug_key < rhs.debug_key)
    return true;
  if (rhs.debug_key < lhs.debug_key)
    return false;
  if (lhs.aggregatable_dedup_keys < rhs.aggregatable_dedup_keys)
    return true;
  if (rhs.aggregatable_dedup_keys < lhs.aggregatable_dedup_keys)
    return false;
  if (lhs.debug_reporting < rhs.debug_reporting)
    return true;
  if (rhs.debug_reporting < lhs.debug_reporting)
    return false;
  if (lhs.aggregation_coordinator < rhs.aggregation_coordinator)
    return true;
  if (rhs.aggregation_coordinator < lhs.aggregation_coordinator)
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace attribution_reporting

namespace mojo {


template <>
struct PLATFORM_EXPORT StructTraits<::attribution_reporting::mojom::blink::DebugKey::DataView,
                                         ::attribution_reporting::mojom::blink::DebugKeyPtr> {
  static bool IsNull(const ::attribution_reporting::mojom::blink::DebugKeyPtr& input) { return !input; }
  static void SetToNull(::attribution_reporting::mojom::blink::DebugKeyPtr* output) { output->reset(); }

  static decltype(::attribution_reporting::mojom::blink::DebugKey::value) value(
      const ::attribution_reporting::mojom::blink::DebugKeyPtr& input) {
    return input->value;
  }

  static bool Read(::attribution_reporting::mojom::blink::DebugKey::DataView input, ::attribution_reporting::mojom::blink::DebugKeyPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::attribution_reporting::mojom::blink::SuitableOrigin::DataView,
                                         ::attribution_reporting::mojom::blink::SuitableOriginPtr> {
  static bool IsNull(const ::attribution_reporting::mojom::blink::SuitableOriginPtr& input) { return !input; }
  static void SetToNull(::attribution_reporting::mojom::blink::SuitableOriginPtr* output) { output->reset(); }

  static const decltype(::attribution_reporting::mojom::blink::SuitableOrigin::origin)& origin(
      const ::attribution_reporting::mojom::blink::SuitableOriginPtr& input) {
    return input->origin;
  }

  static bool Read(::attribution_reporting::mojom::blink::SuitableOrigin::DataView input, ::attribution_reporting::mojom::blink::SuitableOriginPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::attribution_reporting::mojom::blink::FilterData::DataView,
                                         ::attribution_reporting::mojom::blink::FilterDataPtr> {
  static bool IsNull(const ::attribution_reporting::mojom::blink::FilterDataPtr& input) { return !input; }
  static void SetToNull(::attribution_reporting::mojom::blink::FilterDataPtr* output) { output->reset(); }

  static const decltype(::attribution_reporting::mojom::blink::FilterData::filter_values)& filter_values(
      const ::attribution_reporting::mojom::blink::FilterDataPtr& input) {
    return input->filter_values;
  }

  static bool Read(::attribution_reporting::mojom::blink::FilterData::DataView input, ::attribution_reporting::mojom::blink::FilterDataPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::attribution_reporting::mojom::blink::Filters::DataView,
                                         ::attribution_reporting::mojom::blink::FiltersPtr> {
  static bool IsNull(const ::attribution_reporting::mojom::blink::FiltersPtr& input) { return !input; }
  static void SetToNull(::attribution_reporting::mojom::blink::FiltersPtr* output) { output->reset(); }

  static const decltype(::attribution_reporting::mojom::blink::Filters::filter_values)& filter_values(
      const ::attribution_reporting::mojom::blink::FiltersPtr& input) {
    return input->filter_values;
  }

  static bool Read(::attribution_reporting::mojom::blink::Filters::DataView input, ::attribution_reporting::mojom::blink::FiltersPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::attribution_reporting::mojom::blink::FilterPair::DataView,
                                         ::attribution_reporting::mojom::blink::FilterPairPtr> {
  static bool IsNull(const ::attribution_reporting::mojom::blink::FilterPairPtr& input) { return !input; }
  static void SetToNull(::attribution_reporting::mojom::blink::FilterPairPtr* output) { output->reset(); }

  static const decltype(::attribution_reporting::mojom::blink::FilterPair::positive)& positive(
      const ::attribution_reporting::mojom::blink::FilterPairPtr& input) {
    return input->positive;
  }

  static const decltype(::attribution_reporting::mojom::blink::FilterPair::negative)& negative(
      const ::attribution_reporting::mojom::blink::FilterPairPtr& input) {
    return input->negative;
  }

  static bool Read(::attribution_reporting::mojom::blink::FilterPair::DataView input, ::attribution_reporting::mojom::blink::FilterPairPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::attribution_reporting::mojom::blink::AggregationKeys::DataView,
                                         ::attribution_reporting::mojom::blink::AggregationKeysPtr> {
  static bool IsNull(const ::attribution_reporting::mojom::blink::AggregationKeysPtr& input) { return !input; }
  static void SetToNull(::attribution_reporting::mojom::blink::AggregationKeysPtr* output) { output->reset(); }

  static const decltype(::attribution_reporting::mojom::blink::AggregationKeys::keys)& keys(
      const ::attribution_reporting::mojom::blink::AggregationKeysPtr& input) {
    return input->keys;
  }

  static bool Read(::attribution_reporting::mojom::blink::AggregationKeys::DataView input, ::attribution_reporting::mojom::blink::AggregationKeysPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::attribution_reporting::mojom::blink::AggregatableTriggerData::DataView,
                                         ::attribution_reporting::mojom::blink::AggregatableTriggerDataPtr> {
  static bool IsNull(const ::attribution_reporting::mojom::blink::AggregatableTriggerDataPtr& input) { return !input; }
  static void SetToNull(::attribution_reporting::mojom::blink::AggregatableTriggerDataPtr* output) { output->reset(); }

  static const decltype(::attribution_reporting::mojom::blink::AggregatableTriggerData::key_piece)& key_piece(
      const ::attribution_reporting::mojom::blink::AggregatableTriggerDataPtr& input) {
    return input->key_piece;
  }

  static const decltype(::attribution_reporting::mojom::blink::AggregatableTriggerData::source_keys)& source_keys(
      const ::attribution_reporting::mojom::blink::AggregatableTriggerDataPtr& input) {
    return input->source_keys;
  }

  static const decltype(::attribution_reporting::mojom::blink::AggregatableTriggerData::filters)& filters(
      const ::attribution_reporting::mojom::blink::AggregatableTriggerDataPtr& input) {
    return input->filters;
  }

  static bool Read(::attribution_reporting::mojom::blink::AggregatableTriggerData::DataView input, ::attribution_reporting::mojom::blink::AggregatableTriggerDataPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::attribution_reporting::mojom::blink::SourceRegistration::DataView,
                                         ::attribution_reporting::mojom::blink::SourceRegistrationPtr> {
  static bool IsNull(const ::attribution_reporting::mojom::blink::SourceRegistrationPtr& input) { return !input; }
  static void SetToNull(::attribution_reporting::mojom::blink::SourceRegistrationPtr* output) { output->reset(); }

  static const decltype(::attribution_reporting::mojom::blink::SourceRegistration::destinations)& destinations(
      const ::attribution_reporting::mojom::blink::SourceRegistrationPtr& input) {
    return input->destinations;
  }

  static decltype(::attribution_reporting::mojom::blink::SourceRegistration::source_event_id) source_event_id(
      const ::attribution_reporting::mojom::blink::SourceRegistrationPtr& input) {
    return input->source_event_id;
  }

  static const decltype(::attribution_reporting::mojom::blink::SourceRegistration::expiry)& expiry(
      const ::attribution_reporting::mojom::blink::SourceRegistrationPtr& input) {
    return input->expiry;
  }

  static const decltype(::attribution_reporting::mojom::blink::SourceRegistration::event_report_window)& event_report_window(
      const ::attribution_reporting::mojom::blink::SourceRegistrationPtr& input) {
    return input->event_report_window;
  }

  static const decltype(::attribution_reporting::mojom::blink::SourceRegistration::aggregatable_report_window)& aggregatable_report_window(
      const ::attribution_reporting::mojom::blink::SourceRegistrationPtr& input) {
    return input->aggregatable_report_window;
  }

  static decltype(::attribution_reporting::mojom::blink::SourceRegistration::priority) priority(
      const ::attribution_reporting::mojom::blink::SourceRegistrationPtr& input) {
    return input->priority;
  }

  static const decltype(::attribution_reporting::mojom::blink::SourceRegistration::debug_key)& debug_key(
      const ::attribution_reporting::mojom::blink::SourceRegistrationPtr& input) {
    return input->debug_key;
  }

  static const decltype(::attribution_reporting::mojom::blink::SourceRegistration::filter_data)& filter_data(
      const ::attribution_reporting::mojom::blink::SourceRegistrationPtr& input) {
    return input->filter_data;
  }

  static const decltype(::attribution_reporting::mojom::blink::SourceRegistration::aggregation_keys)& aggregation_keys(
      const ::attribution_reporting::mojom::blink::SourceRegistrationPtr& input) {
    return input->aggregation_keys;
  }

  static decltype(::attribution_reporting::mojom::blink::SourceRegistration::debug_reporting) debug_reporting(
      const ::attribution_reporting::mojom::blink::SourceRegistrationPtr& input) {
    return input->debug_reporting;
  }

  static bool Read(::attribution_reporting::mojom::blink::SourceRegistration::DataView input, ::attribution_reporting::mojom::blink::SourceRegistrationPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::attribution_reporting::mojom::blink::TriggerDedupKey::DataView,
                                         ::attribution_reporting::mojom::blink::TriggerDedupKeyPtr> {
  static bool IsNull(const ::attribution_reporting::mojom::blink::TriggerDedupKeyPtr& input) { return !input; }
  static void SetToNull(::attribution_reporting::mojom::blink::TriggerDedupKeyPtr* output) { output->reset(); }

  static decltype(::attribution_reporting::mojom::blink::TriggerDedupKey::value) value(
      const ::attribution_reporting::mojom::blink::TriggerDedupKeyPtr& input) {
    return input->value;
  }

  static bool Read(::attribution_reporting::mojom::blink::TriggerDedupKey::DataView input, ::attribution_reporting::mojom::blink::TriggerDedupKeyPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::attribution_reporting::mojom::blink::EventTriggerData::DataView,
                                         ::attribution_reporting::mojom::blink::EventTriggerDataPtr> {
  static bool IsNull(const ::attribution_reporting::mojom::blink::EventTriggerDataPtr& input) { return !input; }
  static void SetToNull(::attribution_reporting::mojom::blink::EventTriggerDataPtr* output) { output->reset(); }

  static decltype(::attribution_reporting::mojom::blink::EventTriggerData::data) data(
      const ::attribution_reporting::mojom::blink::EventTriggerDataPtr& input) {
    return input->data;
  }

  static decltype(::attribution_reporting::mojom::blink::EventTriggerData::priority) priority(
      const ::attribution_reporting::mojom::blink::EventTriggerDataPtr& input) {
    return input->priority;
  }

  static const decltype(::attribution_reporting::mojom::blink::EventTriggerData::dedup_key)& dedup_key(
      const ::attribution_reporting::mojom::blink::EventTriggerDataPtr& input) {
    return input->dedup_key;
  }

  static const decltype(::attribution_reporting::mojom::blink::EventTriggerData::filters)& filters(
      const ::attribution_reporting::mojom::blink::EventTriggerDataPtr& input) {
    return input->filters;
  }

  static bool Read(::attribution_reporting::mojom::blink::EventTriggerData::DataView input, ::attribution_reporting::mojom::blink::EventTriggerDataPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::attribution_reporting::mojom::blink::AggregatableDedupKey::DataView,
                                         ::attribution_reporting::mojom::blink::AggregatableDedupKeyPtr> {
  static bool IsNull(const ::attribution_reporting::mojom::blink::AggregatableDedupKeyPtr& input) { return !input; }
  static void SetToNull(::attribution_reporting::mojom::blink::AggregatableDedupKeyPtr* output) { output->reset(); }

  static const decltype(::attribution_reporting::mojom::blink::AggregatableDedupKey::dedup_key)& dedup_key(
      const ::attribution_reporting::mojom::blink::AggregatableDedupKeyPtr& input) {
    return input->dedup_key;
  }

  static const decltype(::attribution_reporting::mojom::blink::AggregatableDedupKey::filters)& filters(
      const ::attribution_reporting::mojom::blink::AggregatableDedupKeyPtr& input) {
    return input->filters;
  }

  static bool Read(::attribution_reporting::mojom::blink::AggregatableDedupKey::DataView input, ::attribution_reporting::mojom::blink::AggregatableDedupKeyPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::attribution_reporting::mojom::blink::TriggerRegistration::DataView,
                                         ::attribution_reporting::mojom::blink::TriggerRegistrationPtr> {
  static bool IsNull(const ::attribution_reporting::mojom::blink::TriggerRegistrationPtr& input) { return !input; }
  static void SetToNull(::attribution_reporting::mojom::blink::TriggerRegistrationPtr* output) { output->reset(); }

  static const decltype(::attribution_reporting::mojom::blink::TriggerRegistration::event_triggers)& event_triggers(
      const ::attribution_reporting::mojom::blink::TriggerRegistrationPtr& input) {
    return input->event_triggers;
  }

  static const decltype(::attribution_reporting::mojom::blink::TriggerRegistration::filters)& filters(
      const ::attribution_reporting::mojom::blink::TriggerRegistrationPtr& input) {
    return input->filters;
  }

  static const decltype(::attribution_reporting::mojom::blink::TriggerRegistration::aggregatable_trigger_data)& aggregatable_trigger_data(
      const ::attribution_reporting::mojom::blink::TriggerRegistrationPtr& input) {
    return input->aggregatable_trigger_data;
  }

  static const decltype(::attribution_reporting::mojom::blink::TriggerRegistration::aggregatable_values)& aggregatable_values(
      const ::attribution_reporting::mojom::blink::TriggerRegistrationPtr& input) {
    return input->aggregatable_values;
  }

  static const decltype(::attribution_reporting::mojom::blink::TriggerRegistration::debug_key)& debug_key(
      const ::attribution_reporting::mojom::blink::TriggerRegistrationPtr& input) {
    return input->debug_key;
  }

  static const decltype(::attribution_reporting::mojom::blink::TriggerRegistration::aggregatable_dedup_keys)& aggregatable_dedup_keys(
      const ::attribution_reporting::mojom::blink::TriggerRegistrationPtr& input) {
    return input->aggregatable_dedup_keys;
  }

  static decltype(::attribution_reporting::mojom::blink::TriggerRegistration::debug_reporting) debug_reporting(
      const ::attribution_reporting::mojom::blink::TriggerRegistrationPtr& input) {
    return input->debug_reporting;
  }

  static decltype(::attribution_reporting::mojom::blink::TriggerRegistration::aggregation_coordinator) aggregation_coordinator(
      const ::attribution_reporting::mojom::blink::TriggerRegistrationPtr& input) {
    return input->aggregation_coordinator;
  }

  static bool Read(::attribution_reporting::mojom::blink::TriggerRegistration::DataView input, ::attribution_reporting::mojom::blink::TriggerRegistrationPtr* output);
};

}  // namespace mojo

#endif  // COMPONENTS_ATTRIBUTION_REPORTING_REGISTRATION_MOJOM_BLINK_H_