// content/services/auction_worklet/public/mojom/seller_worklet.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "content/services/auction_worklet/public/mojom/seller_worklet.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "content/services/auction_worklet/public/mojom/seller_worklet.mojom-params-data.h"
namespace auction_worklet {
namespace mojom {

static NOINLINE const char* RejectReasonToStringHelper(RejectReason value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case RejectReason::kNotAvailable:
      return "kNotAvailable";
    case RejectReason::kInvalidBid:
      return "kInvalidBid";
    case RejectReason::kBidBelowAuctionFloor:
      return "kBidBelowAuctionFloor";
    case RejectReason::kPendingApprovalByExchange:
      return "kPendingApprovalByExchange";
    case RejectReason::kDisapprovedByExchange:
      return "kDisapprovedByExchange";
    case RejectReason::kBlockedByPublisher:
      return "kBlockedByPublisher";
    case RejectReason::kLanguageExclusions:
      return "kLanguageExclusions";
    case RejectReason::kCategoryExclusions:
      return "kCategoryExclusions";
    default:
      return nullptr;
  }
}

std::string RejectReasonToString(RejectReason value) {
  const char *str = RejectReasonToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown RejectReason value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, RejectReason value) {
  return os << RejectReasonToString(value);
}

namespace internal {
// static
bool ComponentAuctionOtherSeller_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context,
    bool inlined) {
  if (!data) {
    DCHECK(!inlined);
    return true;
  }

  // If it is inlined, the alignment is already enforced by its enclosing
  // object. We don't have to validate that.
  DCHECK(!inlined || mojo::internal::IsAligned(data));

  if (!inlined &&
      !mojo::internal::ValidateNonInlinedUnionHeaderAndClaimMemory(
          data, validation_context)) {
    return false;
  }

  const ComponentAuctionOtherSeller_Data* object = static_cast<const ComponentAuctionOtherSeller_Data*>(data);

  if (inlined && object->is_null())
    return true;

  switch (object->tag) {

    case ComponentAuctionOtherSeller_Tag::kTopLevelSeller: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_top_level_seller, 1, validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateStruct(object->data.f_top_level_seller, validation_context))
        return false;
      return true;
    }
    case ComponentAuctionOtherSeller_Tag::kComponentSeller: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_component_seller, 2, validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateStruct(object->data.f_component_seller, validation_context))
        return false;
      return true;
    }
    default: {

      ReportValidationError(
          validation_context,
          mojo::internal::VALIDATION_ERROR_UNKNOWN_UNION_TAG,
          "unknown tag in ComponentAuctionOtherSeller");
      return false;
    }
  }
}


// static
bool ComponentAuctionModifiedBidParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ComponentAuctionModifiedBidParams_Data* object =
      static_cast<const ComponentAuctionModifiedBidParams_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->ad, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& ad_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->ad, validation_context,
                                         &ad_validate_params)) {
    return false;
  }

  return true;
}

ComponentAuctionModifiedBidParams_Data::ComponentAuctionModifiedBidParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool ComponentAuctionReportResultParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ComponentAuctionReportResultParams_Data* object =
      static_cast<const ComponentAuctionReportResultParams_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->top_level_seller_signals, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& top_level_seller_signals_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->top_level_seller_signals, validation_context,
                                         &top_level_seller_signals_validate_params)) {
    return false;
  }

  return true;
}

ComponentAuctionReportResultParams_Data::ComponentAuctionReportResultParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool ScoreAdClient_OnScoreAdComplete_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 72, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ScoreAdClient_OnScoreAdComplete_Params_Data* object =
      static_cast<const ScoreAdClient_OnScoreAdComplete_Params_Data*>(data);


  if (!::auction_worklet::mojom::internal::RejectReason_Data
        ::Validate(object->reject_reason, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->component_auction_modified_bid_params, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->debug_loss_report_url, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->debug_win_report_url, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->pa_requests, 8, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& pa_requests_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->pa_requests, validation_context,
                                         &pa_requests_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->errors, 9, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& errors_validate_params =
      mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>();
  if (!mojo::internal::ValidateContainer(object->errors, validation_context,
                                         &errors_validate_params)) {
    return false;
  }

  return true;
}

ScoreAdClient_OnScoreAdComplete_Params_Data::ScoreAdClient_OnScoreAdComplete_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool SellerWorklet_ScoreAd_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 120, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SellerWorklet_ScoreAd_Params_Data* object =
      static_cast<const SellerWorklet_ScoreAd_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->ad_metadata_json, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& ad_metadata_json_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->ad_metadata_json, validation_context,
                                         &ad_metadata_json_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->auction_ad_config_non_shared_params, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->auction_ad_config_non_shared_params, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->direct_from_seller_seller_signals, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->direct_from_seller_auction_signals, validation_context))
    return false;

  if (!mojo::internal::ValidateInlinedUnion(object->browser_signals_other_seller, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->browser_signal_interest_group_owner, 7, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->browser_signal_interest_group_owner, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->browser_signal_render_url, 8, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->browser_signal_render_url, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->browser_signal_ad_component_render_urls, 9, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& browser_signal_ad_component_render_urls_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->browser_signal_ad_component_render_urls, validation_context,
                                         &browser_signal_ad_component_render_urls_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidateStruct(object->seller_timeout, validation_context))
    return false;

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->score_ad_client, 13, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->score_ad_client,
                                                 validation_context)) {
    return false;
  }

  return true;
}

SellerWorklet_ScoreAd_Params_Data::SellerWorklet_ScoreAd_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool SellerWorklet_SendPendingSignalsRequests_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SellerWorklet_SendPendingSignalsRequests_Params_Data* object =
      static_cast<const SellerWorklet_SendPendingSignalsRequests_Params_Data*>(data);

  return true;
}

SellerWorklet_SendPendingSignalsRequests_Params_Data::SellerWorklet_SendPendingSignalsRequests_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool SellerWorklet_ReportResult_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 112, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SellerWorklet_ReportResult_Params_Data* object =
      static_cast<const SellerWorklet_ReportResult_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->auction_ad_config_non_shared_params, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->auction_ad_config_non_shared_params, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->direct_from_seller_seller_signals, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->direct_from_seller_auction_signals, validation_context))
    return false;

  if (!mojo::internal::ValidateInlinedUnion(object->browser_signals_other_seller, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->browser_signal_interest_group_owner, 5, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->browser_signal_interest_group_owner, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->browser_signal_render_url, 6, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->browser_signal_render_url, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->browser_signals_component_auction_report_result_params, validation_context))
    return false;

  return true;
}

SellerWorklet_ReportResult_Params_Data::SellerWorklet_ReportResult_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool SellerWorklet_ReportResult_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 48, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SellerWorklet_ReportResult_ResponseParams_Data* object =
      static_cast<const SellerWorklet_ReportResult_ResponseParams_Data*>(data);

  constexpr const mojo::internal::ContainerValidateParams& signals_for_winner_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->signals_for_winner, validation_context,
                                         &signals_for_winner_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidateStruct(object->report_url, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->ad_beacon_map, 3, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& ad_beacon_map_validate_params =
      mojo::internal::GetMapValidator<*&mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>(), *&mojo::internal::GetArrayValidator<0, false, nullptr>()>();
  if (!mojo::internal::ValidateContainer(object->ad_beacon_map, validation_context,
                                         &ad_beacon_map_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->pa_requests, 4, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& pa_requests_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->pa_requests, validation_context,
                                         &pa_requests_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->error_msgs, 5, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& error_msgs_validate_params =
      mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>();
  if (!mojo::internal::ValidateContainer(object->error_msgs, validation_context,
                                         &error_msgs_validate_params)) {
    return false;
  }

  return true;
}

SellerWorklet_ReportResult_ResponseParams_Data::SellerWorklet_ReportResult_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool SellerWorklet_ConnectDevToolsAgent_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SellerWorklet_ConnectDevToolsAgent_Params_Data* object =
      static_cast<const SellerWorklet_ConnectDevToolsAgent_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->agent, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->agent,
                                                 validation_context)) {
    return false;
  }

  return true;
}

SellerWorklet_ConnectDevToolsAgent_Params_Data::SellerWorklet_ConnectDevToolsAgent_Params_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace auction_worklet

namespace perfetto {

// static
void TraceFormatTraits<::auction_worklet::mojom::RejectReason>::WriteIntoTrace(
   perfetto::TracedValue context, ::auction_worklet::mojom::RejectReason value) {
  return std::move(context).WriteString(::auction_worklet::mojom::RejectReasonToString(value));
}

} // namespace perfetto