// Copyright 2024 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   extensions/common/api/automation_internal.idl
// by tools/json_schema_compiler.
// DO NOT EDIT.

#ifndef EXTENSIONS_COMMON_API_AUTOMATION_INTERNAL_H__
#define EXTENSIONS_COMMON_API_AUTOMATION_INTERNAL_H__

#include <stdint.h>

#include <map>
#include <memory>
#include <string>
#include <vector>

#include "base/values.h"

namespace extensions {
namespace api {
namespace automation_internal {

//
// Types
//

struct AXEventParams {
  AXEventParams();
  ~AXEventParams();
  AXEventParams(const AXEventParams&) = delete;
  AXEventParams& operator=(const AXEventParams&) = delete;
  AXEventParams(AXEventParams&& rhs);
  AXEventParams& operator=(AXEventParams&& rhs);

  // Populates a AXEventParams object from a base::Value. Returns whether |out|
  // was successfully populated.
  static bool Populate(const base::Value& value, AXEventParams* out);

  // Creates a AXEventParams object from a base::Value, or NULL on failure.
  static std::unique_ptr<AXEventParams> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisAXEventParams object.
  base::Value::Dict ToValue() const;

};

struct AXTextLocationParams {
  AXTextLocationParams();
  ~AXTextLocationParams();
  AXTextLocationParams(const AXTextLocationParams&) = delete;
  AXTextLocationParams& operator=(const AXTextLocationParams&) = delete;
  AXTextLocationParams(AXTextLocationParams&& rhs);
  AXTextLocationParams& operator=(AXTextLocationParams&& rhs);

  // Populates a AXTextLocationParams object from a base::Value. Returns whether
  // |out| was successfully populated.
  static bool Populate(const base::Value& value, AXTextLocationParams* out);

  // Creates a AXTextLocationParams object from a base::Value, or NULL on
  // failure.
  static std::unique_ptr<AXTextLocationParams> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisAXTextLocationParams object.
  base::Value::Dict ToValue() const;

  std::string tree_id;

  int node_id;

  bool result;

  int left;

  int top;

  int width;

  int height;

  int request_id;

};

struct PerformActionRequiredParams {
  PerformActionRequiredParams();
  ~PerformActionRequiredParams();
  PerformActionRequiredParams(const PerformActionRequiredParams&) = delete;
  PerformActionRequiredParams& operator=(const PerformActionRequiredParams&) = delete;
  PerformActionRequiredParams(PerformActionRequiredParams&& rhs);
  PerformActionRequiredParams& operator=(PerformActionRequiredParams&& rhs);

  // Populates a PerformActionRequiredParams object from a base::Value. Returns
  // whether |out| was successfully populated.
  static bool Populate(const base::Value& value, PerformActionRequiredParams* out);

  // Creates a PerformActionRequiredParams object from a base::Value, or NULL on
  // failure.
  static std::unique_ptr<PerformActionRequiredParams> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisPerformActionRequiredParams object.
  base::Value::Dict ToValue() const;

  std::string tree_id;

  int automation_node_id;

  // This can be either automation::ActionType or
  // automation_internal::ActionTypePrivate.
  std::string action_type;

  absl::optional<int> request_id;

};

struct PerformCustomActionParams {
  PerformCustomActionParams();
  ~PerformCustomActionParams();
  PerformCustomActionParams(const PerformCustomActionParams&) = delete;
  PerformCustomActionParams& operator=(const PerformCustomActionParams&) = delete;
  PerformCustomActionParams(PerformCustomActionParams&& rhs);
  PerformCustomActionParams& operator=(PerformCustomActionParams&& rhs);

  // Populates a PerformCustomActionParams object from a base::Value. Returns
  // whether |out| was successfully populated.
  static bool Populate(const base::Value& value, PerformCustomActionParams* out);

  // Creates a PerformCustomActionParams object from a base::Value, or NULL on
  // failure.
  static std::unique_ptr<PerformCustomActionParams> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisPerformCustomActionParams object.
  base::Value::Dict ToValue() const;

  int custom_action_id;

};

struct SetSelectionParams {
  SetSelectionParams();
  ~SetSelectionParams();
  SetSelectionParams(const SetSelectionParams&) = delete;
  SetSelectionParams& operator=(const SetSelectionParams&) = delete;
  SetSelectionParams(SetSelectionParams&& rhs);
  SetSelectionParams& operator=(SetSelectionParams&& rhs);

  // Populates a SetSelectionParams object from a base::Value. Returns whether
  // |out| was successfully populated.
  static bool Populate(const base::Value& value, SetSelectionParams* out);

  // Creates a SetSelectionParams object from a base::Value, or NULL on failure.
  static std::unique_ptr<SetSelectionParams> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisSetSelectionParams object.
  base::Value::Dict ToValue() const;

  // Reuses ActionRequiredParams automationNodeID to mean anchor node id, and
  // treeID to apply to both anchor and focus node ids.
  int focus_node_id;

  int anchor_offset;

  int focus_offset;

};

struct ReplaceSelectedTextParams {
  ReplaceSelectedTextParams();
  ~ReplaceSelectedTextParams();
  ReplaceSelectedTextParams(const ReplaceSelectedTextParams&) = delete;
  ReplaceSelectedTextParams& operator=(const ReplaceSelectedTextParams&) = delete;
  ReplaceSelectedTextParams(ReplaceSelectedTextParams&& rhs);
  ReplaceSelectedTextParams& operator=(ReplaceSelectedTextParams&& rhs);

  // Populates a ReplaceSelectedTextParams object from a base::Value. Returns
  // whether |out| was successfully populated.
  static bool Populate(const base::Value& value, ReplaceSelectedTextParams* out);

  // Creates a ReplaceSelectedTextParams object from a base::Value, or NULL on
  // failure.
  static std::unique_ptr<ReplaceSelectedTextParams> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisReplaceSelectedTextParams object.
  base::Value::Dict ToValue() const;

  std::string value;

};

struct SetValueParams {
  SetValueParams();
  ~SetValueParams();
  SetValueParams(const SetValueParams&) = delete;
  SetValueParams& operator=(const SetValueParams&) = delete;
  SetValueParams(SetValueParams&& rhs);
  SetValueParams& operator=(SetValueParams&& rhs);

  // Populates a SetValueParams object from a base::Value. Returns whether |out|
  // was successfully populated.
  static bool Populate(const base::Value& value, SetValueParams* out);

  // Creates a SetValueParams object from a base::Value, or NULL on failure.
  static std::unique_ptr<SetValueParams> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisSetValueParams object.
  base::Value::Dict ToValue() const;

  std::string value;

};

struct ScrollToPointParams {
  ScrollToPointParams();
  ~ScrollToPointParams();
  ScrollToPointParams(const ScrollToPointParams&) = delete;
  ScrollToPointParams& operator=(const ScrollToPointParams&) = delete;
  ScrollToPointParams(ScrollToPointParams&& rhs);
  ScrollToPointParams& operator=(ScrollToPointParams&& rhs);

  // Populates a ScrollToPointParams object from a base::Value. Returns whether
  // |out| was successfully populated.
  static bool Populate(const base::Value& value, ScrollToPointParams* out);

  // Creates a ScrollToPointParams object from a base::Value, or NULL on
  // failure.
  static std::unique_ptr<ScrollToPointParams> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisScrollToPointParams object.
  base::Value::Dict ToValue() const;

  int x;

  int y;

};

struct ScrollToPositionAtRowColumnParams {
  ScrollToPositionAtRowColumnParams();
  ~ScrollToPositionAtRowColumnParams();
  ScrollToPositionAtRowColumnParams(const ScrollToPositionAtRowColumnParams&) = delete;
  ScrollToPositionAtRowColumnParams& operator=(const ScrollToPositionAtRowColumnParams&) = delete;
  ScrollToPositionAtRowColumnParams(ScrollToPositionAtRowColumnParams&& rhs);
  ScrollToPositionAtRowColumnParams& operator=(ScrollToPositionAtRowColumnParams&& rhs);

  // Populates a ScrollToPositionAtRowColumnParams object from a base::Value.
  // Returns whether |out| was successfully populated.
  static bool Populate(const base::Value& value, ScrollToPositionAtRowColumnParams* out);

  // Creates a ScrollToPositionAtRowColumnParams object from a base::Value, or
  // NULL on failure.
  static std::unique_ptr<ScrollToPositionAtRowColumnParams> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisScrollToPositionAtRowColumnParams object.
  base::Value::Dict ToValue() const;

  int row;

  int column;

};

struct SetScrollOffsetParams {
  SetScrollOffsetParams();
  ~SetScrollOffsetParams();
  SetScrollOffsetParams(const SetScrollOffsetParams&) = delete;
  SetScrollOffsetParams& operator=(const SetScrollOffsetParams&) = delete;
  SetScrollOffsetParams(SetScrollOffsetParams&& rhs);
  SetScrollOffsetParams& operator=(SetScrollOffsetParams&& rhs);

  // Populates a SetScrollOffsetParams object from a base::Value. Returns
  // whether |out| was successfully populated.
  static bool Populate(const base::Value& value, SetScrollOffsetParams* out);

  // Creates a SetScrollOffsetParams object from a base::Value, or NULL on
  // failure.
  static std::unique_ptr<SetScrollOffsetParams> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisSetScrollOffsetParams object.
  base::Value::Dict ToValue() const;

  int x;

  int y;

};

struct QuerySelectorRequiredParams {
  QuerySelectorRequiredParams();
  ~QuerySelectorRequiredParams();
  QuerySelectorRequiredParams(const QuerySelectorRequiredParams&) = delete;
  QuerySelectorRequiredParams& operator=(const QuerySelectorRequiredParams&) = delete;
  QuerySelectorRequiredParams(QuerySelectorRequiredParams&& rhs);
  QuerySelectorRequiredParams& operator=(QuerySelectorRequiredParams&& rhs);

  // Populates a QuerySelectorRequiredParams object from a base::Value. Returns
  // whether |out| was successfully populated.
  static bool Populate(const base::Value& value, QuerySelectorRequiredParams* out);

  // Creates a QuerySelectorRequiredParams object from a base::Value, or NULL on
  // failure.
  static std::unique_ptr<QuerySelectorRequiredParams> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisQuerySelectorRequiredParams object.
  base::Value::Dict ToValue() const;

  std::string tree_id;

  int automation_node_id;

  std::string selector;

};

struct EnableTabParams {
  EnableTabParams();
  ~EnableTabParams();
  EnableTabParams(const EnableTabParams&) = delete;
  EnableTabParams& operator=(const EnableTabParams&) = delete;
  EnableTabParams(EnableTabParams&& rhs);
  EnableTabParams& operator=(EnableTabParams&& rhs);

  // Populates a EnableTabParams object from a base::Value. Returns whether
  // |out| was successfully populated.
  static bool Populate(const base::Value& value, EnableTabParams* out);

  // Creates a EnableTabParams object from a base::Value, or NULL on failure.
  static std::unique_ptr<EnableTabParams> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisEnableTabParams object.
  base::Value::Dict ToValue() const;

  absl::optional<int> tab_id;

};

struct GetImageDataParams {
  GetImageDataParams();
  ~GetImageDataParams();
  GetImageDataParams(const GetImageDataParams&) = delete;
  GetImageDataParams& operator=(const GetImageDataParams&) = delete;
  GetImageDataParams(GetImageDataParams&& rhs);
  GetImageDataParams& operator=(GetImageDataParams&& rhs);

  // Populates a GetImageDataParams object from a base::Value. Returns whether
  // |out| was successfully populated.
  static bool Populate(const base::Value& value, GetImageDataParams* out);

  // Creates a GetImageDataParams object from a base::Value, or NULL on failure.
  static std::unique_ptr<GetImageDataParams> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisGetImageDataParams object.
  base::Value::Dict ToValue() const;

  int max_width;

  int max_height;

};

struct HitTestParams {
  HitTestParams();
  ~HitTestParams();
  HitTestParams(const HitTestParams&) = delete;
  HitTestParams& operator=(const HitTestParams&) = delete;
  HitTestParams(HitTestParams&& rhs);
  HitTestParams& operator=(HitTestParams&& rhs);

  // Populates a HitTestParams object from a base::Value. Returns whether |out|
  // was successfully populated.
  static bool Populate(const base::Value& value, HitTestParams* out);

  // Creates a HitTestParams object from a base::Value, or NULL on failure.
  static std::unique_ptr<HitTestParams> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisHitTestParams object.
  base::Value::Dict ToValue() const;

  int x;

  int y;

  std::string event_to_fire;

};

struct GetTextLocationDataParams {
  GetTextLocationDataParams();
  ~GetTextLocationDataParams();
  GetTextLocationDataParams(const GetTextLocationDataParams&) = delete;
  GetTextLocationDataParams& operator=(const GetTextLocationDataParams&) = delete;
  GetTextLocationDataParams(GetTextLocationDataParams&& rhs);
  GetTextLocationDataParams& operator=(GetTextLocationDataParams&& rhs);

  // Populates a GetTextLocationDataParams object from a base::Value. Returns
  // whether |out| was successfully populated.
  static bool Populate(const base::Value& value, GetTextLocationDataParams* out);

  // Creates a GetTextLocationDataParams object from a base::Value, or NULL on
  // failure.
  static std::unique_ptr<GetTextLocationDataParams> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisGetTextLocationDataParams object.
  base::Value::Dict ToValue() const;

  int start_index;

  int end_index;

};

struct EnableTabCallbackInfo {
  EnableTabCallbackInfo();
  ~EnableTabCallbackInfo();
  EnableTabCallbackInfo(const EnableTabCallbackInfo&) = delete;
  EnableTabCallbackInfo& operator=(const EnableTabCallbackInfo&) = delete;
  EnableTabCallbackInfo(EnableTabCallbackInfo&& rhs);
  EnableTabCallbackInfo& operator=(EnableTabCallbackInfo&& rhs);

  // Populates a EnableTabCallbackInfo object from a base::Value. Returns
  // whether |out| was successfully populated.
  static bool Populate(const base::Value& value, EnableTabCallbackInfo* out);

  // Creates a EnableTabCallbackInfo object from a base::Value, or NULL on
  // failure.
  static std::unique_ptr<EnableTabCallbackInfo> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisEnableTabCallbackInfo object.
  base::Value::Dict ToValue() const;

  std::string tree_id;

  int tab_id;

};


//
// Functions
//

namespace EnableTab {

struct Params {
  static std::unique_ptr<Params> Create(const base::Value::List& args);
  Params(const Params&) = delete;
  Params& operator=(const Params&) = delete;
  ~Params();

  EnableTabParams args;


 private:
  Params();
};

namespace Results {

base::Value::List Create(const EnableTabCallbackInfo& info);
}  // namespace Results

}  // namespace EnableTab

namespace EnableTree {

struct Params {
  static std::unique_ptr<Params> Create(const base::Value::List& args);
  Params(const Params&) = delete;
  Params& operator=(const Params&) = delete;
  ~Params();

  std::string tree_id;


 private:
  Params();
};

}  // namespace EnableTree

namespace EnableDesktop {

namespace Results {

base::Value::List Create(const std::string& tree_id);
}  // namespace Results

}  // namespace EnableDesktop

namespace DisableDesktop {

namespace Results {

base::Value::List Create();
}  // namespace Results

}  // namespace DisableDesktop

namespace PerformAction {

struct Params {
  static std::unique_ptr<Params> Create(const base::Value::List& args);
  Params(const Params&) = delete;
  Params& operator=(const Params&) = delete;
  ~Params();

  struct OptArgs {
    OptArgs();
    ~OptArgs();
    OptArgs(const OptArgs&) = delete;
    OptArgs& operator=(const OptArgs&) = delete;
    OptArgs(OptArgs&& rhs);
    OptArgs& operator=(OptArgs&& rhs);

    // Populates a OptArgs object from a base::Value. Returns whether |out| was
    // successfully populated.
    static bool Populate(const base::Value& value, OptArgs* out);

    base::Value::Dict additional_properties;
  };


  PerformActionRequiredParams args;

  OptArgs opt_args;


 private:
  Params();
};

}  // namespace PerformAction

namespace QuerySelector {

struct Params {
  static std::unique_ptr<Params> Create(const base::Value::List& args);
  Params(const Params&) = delete;
  Params& operator=(const Params&) = delete;
  ~Params();

  QuerySelectorRequiredParams args;


 private:
  Params();
};

namespace Results {

base::Value::List Create(int result_automation_node_id);
}  // namespace Results

}  // namespace QuerySelector

//
// Events
//

namespace OnAccessibilityEvent {

extern const char kEventName[];  // "automationInternal.onAccessibilityEvent"

base::Value::List Create(const AXEventParams& update);
}  // namespace OnAccessibilityEvent

namespace OnAccessibilityTreeDestroyed {

extern const char kEventName[];  // "automationInternal.onAccessibilityTreeDestroyed"

base::Value::List Create(const std::string& tree_id);
}  // namespace OnAccessibilityTreeDestroyed

namespace OnGetTextLocationResult {

extern const char kEventName[];  // "automationInternal.onGetTextLocationResult"

base::Value::List Create(const AXTextLocationParams& params);
}  // namespace OnGetTextLocationResult

namespace OnTreeChange {

extern const char kEventName[];  // "automationInternal.onTreeChange"

base::Value::List Create(int observer_id, const std::string& tree_id, int node_id, const std::string& change_type);
}  // namespace OnTreeChange

namespace OnChildTreeID {

extern const char kEventName[];  // "automationInternal.onChildTreeID"

base::Value::List Create(const std::string& tree_id);
}  // namespace OnChildTreeID

namespace OnNodesRemoved {

extern const char kEventName[];  // "automationInternal.onNodesRemoved"

base::Value::List Create(const std::string& tree_id, const std::vector<int>& node_i_ds);
}  // namespace OnNodesRemoved

namespace OnAccessibilityTreeSerializationError {

extern const char kEventName[];  // "automationInternal.onAccessibilityTreeSerializationError"

base::Value::List Create(const std::string& tree_id);
}  // namespace OnAccessibilityTreeSerializationError

namespace OnActionResult {

extern const char kEventName[];  // "automationInternal.onActionResult"

base::Value::List Create(const std::string& tree_id, int request_id, bool result);
}  // namespace OnActionResult

namespace OnAllAutomationEventListenersRemoved {

extern const char kEventName[];  // "automationInternal.onAllAutomationEventListenersRemoved"

base::Value::List Create();
}  // namespace OnAllAutomationEventListenersRemoved

}  // namespace automation_internal
}  // namespace api
}  // namespace extensions

#endif  // EXTENSIONS_COMMON_API_AUTOMATION_INTERNAL_H__
