// Copyright 2024 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   extensions/common/api/offscreen.idl
// by tools/json_schema_compiler.
// DO NOT EDIT.

#ifndef EXTENSIONS_COMMON_API_OFFSCREEN_H__
#define EXTENSIONS_COMMON_API_OFFSCREEN_H__

#include <stdint.h>

#include <map>
#include <memory>
#include <string>
#include <vector>

#include "base/values.h"

namespace extensions {
namespace api {
namespace offscreen {

//
// Types
//

enum Reason {
  REASON_NONE,
  REASON_TESTING,
  REASON_AUDIO_PLAYBACK,
  REASON_IFRAME_SCRIPTING,
  REASON_DOM_SCRAPING,
  REASON_BLOBS,
  REASON_DOM_PARSER,
  REASON_USER_MEDIA,
  REASON_DISPLAY_MEDIA,
  REASON_WEB_RTC,
  REASON_CLIPBOARD,
  REASON_LAST = REASON_CLIPBOARD,
};


const char* ToString(Reason as_enum);
Reason ParseReason(const std::string& as_string);

struct CreateParameters {
  CreateParameters();
  ~CreateParameters();
  CreateParameters(const CreateParameters&) = delete;
  CreateParameters& operator=(const CreateParameters&) = delete;
  CreateParameters(CreateParameters&& rhs);
  CreateParameters& operator=(CreateParameters&& rhs);

  // Populates a CreateParameters object from a base::Value. Returns whether
  // |out| was successfully populated.
  static bool Populate(const base::Value& value, CreateParameters* out);

  // Creates a CreateParameters object from a base::Value, or NULL on failure.
  static std::unique_ptr<CreateParameters> FromValue(const base::Value& value);

  // Returns a new base::Value::Dict representing the serialized form of
  // thisCreateParameters object.
  base::Value::Dict ToValue() const;

  // The reason(s) the extension is creating the offscreen document.
  std::vector<Reason> reasons;

  // The (relative) URL to load in the document.
  std::string url;

  // A developer-provided string that explains, in more detail, the need for the
  // background context. The user agent _may_ use this in display to the user.
  std::string justification;

};


//
// Functions
//

namespace CreateDocument {

struct Params {
  static std::unique_ptr<Params> Create(const base::Value::List& args);
  Params(const Params&) = delete;
  Params& operator=(const Params&) = delete;
  ~Params();

  // The parameters describing the offscreen document to create.
  CreateParameters parameters;


 private:
  Params();
};

namespace Results {

base::Value::List Create();
}  // namespace Results

}  // namespace CreateDocument

namespace CloseDocument {

namespace Results {

base::Value::List Create();
}  // namespace Results

}  // namespace CloseDocument

namespace HasDocument {

namespace Results {

base::Value::List Create(bool result);
}  // namespace Results

}  // namespace HasDocument

}  // namespace offscreen
}  // namespace api
}  // namespace extensions

#endif  // EXTENSIONS_COMMON_API_OFFSCREEN_H__
