// Copyright 2024 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   extensions/common/api/power.idl
// by tools/json_schema_compiler.
// DO NOT EDIT.

#include "extensions/common/api/power.h"

#include <memory>
#include <ostream>
#include <string>
#include <utility>
#include <vector>

#include "base/check.h"
#include "base/check_op.h"
#include "base/notreached.h"
#include "base/strings/string_number_conversions.h"
#include "base/strings/utf_string_conversions.h"
#include "base/values.h"
#include "tools/json_schema_compiler/util.h"

using base::UTF8ToUTF16;

namespace extensions {
namespace api {
namespace power {
//
// Types
//

const char* ToString(Level enum_param) {
  switch (enum_param) {
    case LEVEL_SYSTEM:
      return "system";
    case LEVEL_DISPLAY:
      return "display";
    case LEVEL_NONE:
      return "";
  }
  NOTREACHED();
  return "";
}

Level ParseLevel(const std::string& enum_string) {
  if (enum_string == "system")
    return LEVEL_SYSTEM;
  if (enum_string == "display")
    return LEVEL_DISPLAY;
  return LEVEL_NONE;
}



//
// Functions
//

namespace RequestKeepAwake {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::List& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& level_value = args[0];
    {
      const std::string* level_as_string = level_value.GetIfString();
      if (!level_as_string) {
        return std::unique_ptr<Params>();
      }
      params->level = ParseLevel(*level_as_string);
      if (params->level == LEVEL_NONE) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


}  // namespace RequestKeepAwake

namespace ReleaseKeepAwake {

}  // namespace ReleaseKeepAwake

}  // namespace power
}  // namespace api
}  // namespace extensions

