// third_party/blink/public/mojom/back_forward_cache_not_restored_reasons.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/back_forward_cache_not_restored_reasons.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/back_forward_cache_not_restored_reasons.mojom-params-data.h"
namespace blink {
namespace mojom {

static NOINLINE const char* BFCacheBlockedToStringHelper(BFCacheBlocked value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case BFCacheBlocked::kYes:
      return "kYes";
    case BFCacheBlocked::kNo:
      return "kNo";
    case BFCacheBlocked::kMasked:
      return "kMasked";
    default:
      return nullptr;
  }
}

std::string BFCacheBlockedToString(BFCacheBlocked value) {
  const char *str = BFCacheBlockedToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown BFCacheBlocked value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, BFCacheBlocked value) {
  return os << BFCacheBlockedToString(value);
}

namespace internal {


// static
bool SameOriginBfcacheNotRestoredDetails_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SameOriginBfcacheNotRestoredDetails_Data* object =
      static_cast<const SameOriginBfcacheNotRestoredDetails_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->url, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& url_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->url, validation_context,
                                         &url_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->reasons, 2, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& reasons_validate_params =
      mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>();
  if (!mojo::internal::ValidateContainer(object->reasons, validation_context,
                                         &reasons_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->children, 3, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& children_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->children, validation_context,
                                         &children_validate_params)) {
    return false;
  }

  return true;
}

SameOriginBfcacheNotRestoredDetails_Data::SameOriginBfcacheNotRestoredDetails_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool BackForwardCacheNotRestoredReasons_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 48, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const BackForwardCacheNotRestoredReasons_Data* object =
      static_cast<const BackForwardCacheNotRestoredReasons_Data*>(data);


  if (!::blink::mojom::internal::BFCacheBlocked_Data
        ::Validate(object->blocked, validation_context))
    return false;

  constexpr const mojo::internal::ContainerValidateParams& src_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->src, validation_context,
                                         &src_validate_params)) {
    return false;
  }

  constexpr const mojo::internal::ContainerValidateParams& id_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->id, validation_context,
                                         &id_validate_params)) {
    return false;
  }

  constexpr const mojo::internal::ContainerValidateParams& name_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->name, validation_context,
                                         &name_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidateStruct(object->same_origin_details, validation_context))
    return false;

  return true;
}

BackForwardCacheNotRestoredReasons_Data::BackForwardCacheNotRestoredReasons_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::BFCacheBlocked>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::BFCacheBlocked value) {
  return std::move(context).WriteString(::blink::mojom::BFCacheBlockedToString(value));
}

} // namespace perfetto