// third_party/blink/public/mojom/back_forward_cache_not_restored_reasons.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_BACK_FORWARD_CACHE_NOT_RESTORED_REASONS_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_BACK_FORWARD_CACHE_NOT_RESTORED_REASONS_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/back_forward_cache_not_restored_reasons.mojom-shared-internal.h"



#include "base/component_export.h"




namespace blink {
namespace mojom {
class SameOriginBfcacheNotRestoredDetailsDataView;

class BackForwardCacheNotRestoredReasonsDataView;



}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::SameOriginBfcacheNotRestoredDetailsDataView> {
  using Data = ::blink::mojom::internal::SameOriginBfcacheNotRestoredDetails_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::blink::mojom::BackForwardCacheNotRestoredReasonsDataView> {
  using Data = ::blink::mojom::internal::BackForwardCacheNotRestoredReasons_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {


enum class BFCacheBlocked : int32_t {
  
  kYes = 0,
  
  kNo = 1,
  
  kMasked = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, BFCacheBlocked value);
inline bool IsKnownEnumValue(BFCacheBlocked value) {
  return internal::BFCacheBlocked_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


class SameOriginBfcacheNotRestoredDetailsDataView {
 public:
  SameOriginBfcacheNotRestoredDetailsDataView() = default;

  SameOriginBfcacheNotRestoredDetailsDataView(
      internal::SameOriginBfcacheNotRestoredDetails_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetUrlDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadUrl(UserType* output) {
    
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetReasonsDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadReasons(UserType* output) {
    
    auto* pointer = data_->reasons.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        pointer, output, message_);
  }
  inline void GetChildrenDataView(
      mojo::ArrayDataView<BackForwardCacheNotRestoredReasonsDataView>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadChildren(UserType* output) {
    
    auto* pointer = data_->children.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::blink::mojom::BackForwardCacheNotRestoredReasonsDataView>>(
        pointer, output, message_);
  }
 private:
  internal::SameOriginBfcacheNotRestoredDetails_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



class BackForwardCacheNotRestoredReasonsDataView {
 public:
  BackForwardCacheNotRestoredReasonsDataView() = default;

  BackForwardCacheNotRestoredReasonsDataView(
      internal::BackForwardCacheNotRestoredReasons_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  [[nodiscard]] bool ReadBlocked(UserType* output) const {
    auto data_value = data_->blocked;
    return mojo::internal::Deserialize<::blink::mojom::BFCacheBlocked>(
        data_value, output);
  }
  BFCacheBlocked blocked() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::BFCacheBlocked>(data_->blocked));
  }
  inline void GetSrcDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadSrc(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        mojo::StringDataView, UserType>(),
    "Attempting to read the optional `src` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with absl::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadSrc` instead "
    "of `ReadSrc if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->src.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadId(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        mojo::StringDataView, UserType>(),
    "Attempting to read the optional `id` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with absl::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadId` instead "
    "of `ReadId if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadName(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        mojo::StringDataView, UserType>(),
    "Attempting to read the optional `name` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with absl::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadName` instead "
    "of `ReadName if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetSameOriginDetailsDataView(
      SameOriginBfcacheNotRestoredDetailsDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadSameOriginDetails(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::blink::mojom::SameOriginBfcacheNotRestoredDetailsDataView, UserType>(),
    "Attempting to read the optional `same_origin_details` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with absl::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadSameOriginDetails` instead "
    "of `ReadSameOriginDetails if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->same_origin_details.Get();
    return mojo::internal::Deserialize<::blink::mojom::SameOriginBfcacheNotRestoredDetailsDataView>(
        pointer, output, message_);
  }
 private:
  internal::BackForwardCacheNotRestoredReasons_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

template <>
struct hash<::blink::mojom::BFCacheBlocked>
    : public mojo::internal::EnumHashImpl<::blink::mojom::BFCacheBlocked> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::BFCacheBlocked, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::BFCacheBlocked, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::BFCacheBlocked>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::SameOriginBfcacheNotRestoredDetailsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::SameOriginBfcacheNotRestoredDetailsDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::SameOriginBfcacheNotRestoredDetails_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::url(input)) in_url = Traits::url(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->url)::BaseType> url_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_url, url_fragment);
    fragment->url.Set(
        url_fragment.is_null() ? nullptr : url_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->url.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null url in SameOriginBfcacheNotRestoredDetails struct");
    decltype(Traits::reasons(input)) in_reasons = Traits::reasons(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->reasons)::BaseType>
        reasons_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& reasons_validate_params =
        mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>();
    mojo::internal::Serialize<mojo::ArrayDataView<mojo::StringDataView>>(
        in_reasons, reasons_fragment, &reasons_validate_params);
    fragment->reasons.Set(
        reasons_fragment.is_null() ? nullptr : reasons_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->reasons.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null reasons in SameOriginBfcacheNotRestoredDetails struct");
    decltype(Traits::children(input)) in_children = Traits::children(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->children)::BaseType>
        children_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& children_validate_params =
        mojo::internal::GetArrayValidator<0, false, nullptr>();
    mojo::internal::Serialize<mojo::ArrayDataView<::blink::mojom::BackForwardCacheNotRestoredReasonsDataView>>(
        in_children, children_fragment, &children_validate_params);
    fragment->children.Set(
        children_fragment.is_null() ? nullptr : children_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->children.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null children in SameOriginBfcacheNotRestoredDetails struct");
  }

  static bool Deserialize(::blink::mojom::internal::SameOriginBfcacheNotRestoredDetails_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::SameOriginBfcacheNotRestoredDetailsDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::BackForwardCacheNotRestoredReasonsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::BackForwardCacheNotRestoredReasonsDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::BackForwardCacheNotRestoredReasons_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    mojo::internal::Serialize<::blink::mojom::BFCacheBlocked>(
        Traits::blocked(input), &fragment->blocked);
    decltype(Traits::src(input)) in_src = Traits::src(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->src)::BaseType> src_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_src, src_fragment);
    fragment->src.Set(
        src_fragment.is_null() ? nullptr : src_fragment.data());
    decltype(Traits::id(input)) in_id = Traits::id(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->id)::BaseType> id_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_id, id_fragment);
    fragment->id.Set(
        id_fragment.is_null() ? nullptr : id_fragment.data());
    decltype(Traits::name(input)) in_name = Traits::name(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->name)::BaseType> name_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_name, name_fragment);
    fragment->name.Set(
        name_fragment.is_null() ? nullptr : name_fragment.data());
    decltype(Traits::same_origin_details(input)) in_same_origin_details = Traits::same_origin_details(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->same_origin_details)::BaseType> same_origin_details_fragment(
            fragment.message());
    mojo::internal::Serialize<::blink::mojom::SameOriginBfcacheNotRestoredDetailsDataView>(
        in_same_origin_details, same_origin_details_fragment);
    fragment->same_origin_details.Set(
        same_origin_details_fragment.is_null() ? nullptr : same_origin_details_fragment.data());
  }

  static bool Deserialize(::blink::mojom::internal::BackForwardCacheNotRestoredReasons_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::BackForwardCacheNotRestoredReasonsDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {

inline void SameOriginBfcacheNotRestoredDetailsDataView::GetUrlDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->url.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void SameOriginBfcacheNotRestoredDetailsDataView::GetReasonsDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) {
  auto pointer = data_->reasons.Get();
  *output = mojo::ArrayDataView<mojo::StringDataView>(pointer, message_);
}
inline void SameOriginBfcacheNotRestoredDetailsDataView::GetChildrenDataView(
    mojo::ArrayDataView<BackForwardCacheNotRestoredReasonsDataView>* output) {
  auto pointer = data_->children.Get();
  *output = mojo::ArrayDataView<BackForwardCacheNotRestoredReasonsDataView>(pointer, message_);
}


inline void BackForwardCacheNotRestoredReasonsDataView::GetSrcDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->src.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void BackForwardCacheNotRestoredReasonsDataView::GetIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->id.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void BackForwardCacheNotRestoredReasonsDataView::GetNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->name.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void BackForwardCacheNotRestoredReasonsDataView::GetSameOriginDetailsDataView(
    SameOriginBfcacheNotRestoredDetailsDataView* output) {
  auto pointer = data_->same_origin_details.Get();
  *output = SameOriginBfcacheNotRestoredDetailsDataView(pointer, message_);
}



}  // namespace mojom
}  // namespace blink

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::BFCacheBlocked> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::BFCacheBlocked value);
};

} // namespace perfetto

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_BACK_FORWARD_CACHE_NOT_RESTORED_REASONS_MOJOM_SHARED_H_