// third_party/blink/public/mojom/direct_sockets/direct_sockets.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/direct_sockets/direct_sockets.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/direct_sockets/direct_sockets.mojom-params-data.h"
namespace blink {
namespace mojom {

static NOINLINE const char* DirectSocketFailureTypeToStringHelper(DirectSocketFailureType value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case DirectSocketFailureType::kPermissionsPolicy:
      return "kPermissionsPolicy";
    case DirectSocketFailureType::kTransientActivation:
      return "kTransientActivation";
    case DirectSocketFailureType::kUserDialog:
      return "kUserDialog";
    case DirectSocketFailureType::kResolvingToNonPublic:
      return "kResolvingToNonPublic";
    case DirectSocketFailureType::kRateLimiting:
      return "kRateLimiting";
    case DirectSocketFailureType::kCORS:
      return "kCORS";
    case DirectSocketFailureType::kEnterprisePolicy:
      return "kEnterprisePolicy";
    default:
      return nullptr;
  }
}

std::string DirectSocketFailureTypeToString(DirectSocketFailureType value) {
  const char *str = DirectSocketFailureTypeToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown DirectSocketFailureType value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, DirectSocketFailureType value) {
  return os << DirectSocketFailureTypeToString(value);
}

static NOINLINE const char* DirectSocketProtocolTypeToStringHelper(DirectSocketProtocolType value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case DirectSocketProtocolType::kTcp:
      return "kTcp";
    case DirectSocketProtocolType::kUdp:
      return "kUdp";
    case DirectSocketProtocolType::kUdpServer:
      return "kUdpServer";
    default:
      return nullptr;
  }
}

std::string DirectSocketProtocolTypeToString(DirectSocketProtocolType value) {
  const char *str = DirectSocketProtocolTypeToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown DirectSocketProtocolType value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, DirectSocketProtocolType value) {
  return os << DirectSocketProtocolTypeToString(value);
}

namespace internal {


// static
bool DirectTCPSocketOptions_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 48, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectTCPSocketOptions_Data* object =
      static_cast<const DirectTCPSocketOptions_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->remote_addr, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->remote_addr, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->local_addr, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->keep_alive_options, validation_context))
    return false;


  if (!::network::mojom::internal::DnsQueryType_Data
        ::Validate(object->dns_query_type, validation_context))
    return false;

  return true;
}

DirectTCPSocketOptions_Data::DirectTCPSocketOptions_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool DirectUDPSocketOptions_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 40, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectUDPSocketOptions_Data* object =
      static_cast<const DirectUDPSocketOptions_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->remote_addr, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->local_addr, validation_context))
    return false;


  if (!::network::mojom::internal::DnsQueryType_Data
        ::Validate(object->dns_query_type, validation_context))
    return false;

  return true;
}

DirectUDPSocketOptions_Data::DirectUDPSocketOptions_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool DirectTCPServerSocketOptions_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectTCPServerSocketOptions_Data* object =
      static_cast<const DirectTCPServerSocketOptions_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->local_addr, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->local_addr, validation_context))
    return false;

  return true;
}

DirectTCPServerSocketOptions_Data::DirectTCPServerSocketOptions_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool DirectSocketsService_OpenTCPSocket_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectSocketsService_OpenTCPSocket_Params_Data* object =
      static_cast<const DirectSocketsService_OpenTCPSocket_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->options, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->options, validation_context))
    return false;

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->receiver, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->receiver,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterface(object->observer,
                                                 validation_context)) {
    return false;
  }

  return true;
}

DirectSocketsService_OpenTCPSocket_Params_Data::DirectSocketsService_OpenTCPSocket_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool DirectSocketsService_OpenTCPSocket_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 40, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectSocketsService_OpenTCPSocket_ResponseParams_Data* object =
      static_cast<const DirectSocketsService_OpenTCPSocket_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->local_addr, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->peer_addr, validation_context))
    return false;

  if (!mojo::internal::ValidateHandleOrInterface(object->receive_stream,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterface(object->send_stream,
                                                 validation_context)) {
    return false;
  }

  return true;
}

DirectSocketsService_OpenTCPSocket_ResponseParams_Data::DirectSocketsService_OpenTCPSocket_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool DirectSocketsService_OpenUDPSocket_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectSocketsService_OpenUDPSocket_Params_Data* object =
      static_cast<const DirectSocketsService_OpenUDPSocket_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->options, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->options, validation_context))
    return false;

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->receiver, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->receiver,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterface(object->listener,
                                                 validation_context)) {
    return false;
  }

  return true;
}

DirectSocketsService_OpenUDPSocket_Params_Data::DirectSocketsService_OpenUDPSocket_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool DirectSocketsService_OpenUDPSocket_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectSocketsService_OpenUDPSocket_ResponseParams_Data* object =
      static_cast<const DirectSocketsService_OpenUDPSocket_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->local_addr, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->peer_addr, validation_context))
    return false;

  return true;
}

DirectSocketsService_OpenUDPSocket_ResponseParams_Data::DirectSocketsService_OpenUDPSocket_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool DirectSocketsService_OpenTCPServerSocket_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectSocketsService_OpenTCPServerSocket_Params_Data* object =
      static_cast<const DirectSocketsService_OpenTCPServerSocket_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->options, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->options, validation_context))
    return false;

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->receiver, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->receiver,
                                                 validation_context)) {
    return false;
  }

  return true;
}

DirectSocketsService_OpenTCPServerSocket_Params_Data::DirectSocketsService_OpenTCPServerSocket_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool DirectSocketsService_OpenTCPServerSocket_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectSocketsService_OpenTCPServerSocket_ResponseParams_Data* object =
      static_cast<const DirectSocketsService_OpenTCPServerSocket_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->local_addr, validation_context))
    return false;

  return true;
}

DirectSocketsService_OpenTCPServerSocket_ResponseParams_Data::DirectSocketsService_OpenTCPServerSocket_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::DirectSocketFailureType>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::DirectSocketFailureType value) {
  return std::move(context).WriteString(::blink::mojom::DirectSocketFailureTypeToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::DirectSocketProtocolType>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::DirectSocketProtocolType value) {
  return std::move(context).WriteString(::blink::mojom::DirectSocketProtocolTypeToString(value));
}

} // namespace perfetto