// third_party/blink/public/mojom/direct_sockets/direct_sockets.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_DIRECT_SOCKETS_DIRECT_SOCKETS_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_DIRECT_SOCKETS_DIRECT_SOCKETS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/direct_sockets/direct_sockets.mojom-shared.h"
#include "third_party/blink/public/mojom/direct_sockets/direct_sockets.mojom-forward.h"
#include "mojo/public/mojom/base/read_only_buffer.mojom-forward.h"
#include "services/network/public/mojom/host_resolver.mojom.h"
#include "services/network/public/mojom/ip_endpoint.mojom.h"
#include "services/network/public/mojom/mutable_network_traffic_annotation_tag.mojom-forward.h"
#include "services/network/public/mojom/network_param.mojom.h"
#include "services/network/public/mojom/restricted_udp_socket.mojom-forward.h"
#include "services/network/public/mojom/tcp_socket.mojom.h"
#include "services/network/public/mojom/udp_socket.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink {
namespace mojom {

class DirectSocketsServiceProxy;

template <typename ImplRefTraits>
class DirectSocketsServiceStub;

class DirectSocketsServiceRequestValidator;
class DirectSocketsServiceResponseValidator;


class BLINK_COMMON_EXPORT DirectSocketsService
    : public DirectSocketsServiceInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = DirectSocketsServiceInterfaceBase;
  using Proxy_ = DirectSocketsServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = DirectSocketsServiceStub<ImplRefTraits>;

  using RequestValidator_ = DirectSocketsServiceRequestValidator;
  using ResponseValidator_ = DirectSocketsServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kOpenTCPSocketMinVersion = 0,
    kOpenUDPSocketMinVersion = 0,
    kOpenTCPServerSocketMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct OpenTCPSocket_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct OpenUDPSocket_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct OpenTCPServerSocket_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~DirectSocketsService() = default;


  using OpenTCPSocketCallback = base::OnceCallback<void(int32_t, const absl::optional<::net::IPEndPoint>&, const absl::optional<::net::IPEndPoint>&, ::mojo::ScopedDataPipeConsumerHandle, ::mojo::ScopedDataPipeProducerHandle)>;
  
  virtual void OpenTCPSocket(DirectTCPSocketOptionsPtr options, ::mojo::PendingReceiver<::network::mojom::TCPConnectedSocket> receiver, ::mojo::PendingRemote<::network::mojom::SocketObserver> observer, OpenTCPSocketCallback callback) = 0;


  using OpenUDPSocketCallback = base::OnceCallback<void(int32_t, const absl::optional<::net::IPEndPoint>&, const absl::optional<::net::IPEndPoint>&)>;
  
  virtual void OpenUDPSocket(DirectUDPSocketOptionsPtr options, ::mojo::PendingReceiver<::network::mojom::RestrictedUDPSocket> receiver, ::mojo::PendingRemote<::network::mojom::UDPSocketListener> listener, OpenUDPSocketCallback callback) = 0;


  using OpenTCPServerSocketCallback = base::OnceCallback<void(int32_t, const absl::optional<::net::IPEndPoint>&)>;
  
  virtual void OpenTCPServerSocket(DirectTCPServerSocketOptionsPtr options, ::mojo::PendingReceiver<::network::mojom::TCPServerSocket> receiver, OpenTCPServerSocketCallback callback) = 0;
};



class BLINK_COMMON_EXPORT DirectSocketsServiceProxy
    : public DirectSocketsService {
 public:
  using InterfaceType = DirectSocketsService;

  explicit DirectSocketsServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OpenTCPSocket(DirectTCPSocketOptionsPtr options, ::mojo::PendingReceiver<::network::mojom::TCPConnectedSocket> receiver, ::mojo::PendingRemote<::network::mojom::SocketObserver> observer, OpenTCPSocketCallback callback) final;
  
  void OpenUDPSocket(DirectUDPSocketOptionsPtr options, ::mojo::PendingReceiver<::network::mojom::RestrictedUDPSocket> receiver, ::mojo::PendingRemote<::network::mojom::UDPSocketListener> listener, OpenUDPSocketCallback callback) final;
  
  void OpenTCPServerSocket(DirectTCPServerSocketOptionsPtr options, ::mojo::PendingReceiver<::network::mojom::TCPServerSocket> receiver, OpenTCPServerSocketCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT DirectSocketsServiceStubDispatch {
 public:
  static bool Accept(DirectSocketsService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      DirectSocketsService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<DirectSocketsService>>
class DirectSocketsServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  DirectSocketsServiceStub() = default;
  ~DirectSocketsServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DirectSocketsServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DirectSocketsServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT DirectSocketsServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT DirectSocketsServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};










class BLINK_COMMON_EXPORT DirectTCPSocketOptions {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DirectTCPSocketOptions, T>::value>;
  using DataView = DirectTCPSocketOptionsDataView;
  using Data_ = internal::DirectTCPSocketOptions_Data;

  template <typename... Args>
  static DirectTCPSocketOptionsPtr New(Args&&... args) {
    return DirectTCPSocketOptionsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DirectTCPSocketOptionsPtr From(const U& u) {
    return mojo::TypeConverter<DirectTCPSocketOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DirectTCPSocketOptions>::Convert(*this);
  }


  DirectTCPSocketOptions();

  DirectTCPSocketOptions(
      const ::net::HostPortPair& remote_addr,
      const absl::optional<::net::IPEndPoint>& local_addr,
      int32_t send_buffer_size,
      int32_t receive_buffer_size,
      bool no_delay,
      ::network::mojom::TCPKeepAliveOptionsPtr keep_alive_options,
      ::net::DnsQueryType dns_query_type);

DirectTCPSocketOptions(const DirectTCPSocketOptions&) = delete;
DirectTCPSocketOptions& operator=(const DirectTCPSocketOptions&) = delete;

  ~DirectTCPSocketOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DirectTCPSocketOptionsPtr>
  DirectTCPSocketOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DirectTCPSocketOptions::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, DirectTCPSocketOptions::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DirectTCPSocketOptions::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DirectTCPSocketOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DirectTCPSocketOptions_UnserializedMessageContext<
            UserType, DirectTCPSocketOptions::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<DirectTCPSocketOptions::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return DirectTCPSocketOptions::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DirectTCPSocketOptions_UnserializedMessageContext<
            UserType, DirectTCPSocketOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DirectTCPSocketOptions::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::net::HostPortPair remote_addr;
  
  absl::optional<::net::IPEndPoint> local_addr;
  
  int32_t send_buffer_size;
  
  int32_t receive_buffer_size;
  
  bool no_delay;
  
  ::network::mojom::TCPKeepAliveOptionsPtr keep_alive_options;
  
  ::net::DnsQueryType dns_query_type;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DirectTCPSocketOptions::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DirectTCPSocketOptions::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DirectTCPSocketOptions::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DirectTCPSocketOptions::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT DirectUDPSocketOptions {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DirectUDPSocketOptions, T>::value>;
  using DataView = DirectUDPSocketOptionsDataView;
  using Data_ = internal::DirectUDPSocketOptions_Data;

  template <typename... Args>
  static DirectUDPSocketOptionsPtr New(Args&&... args) {
    return DirectUDPSocketOptionsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DirectUDPSocketOptionsPtr From(const U& u) {
    return mojo::TypeConverter<DirectUDPSocketOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DirectUDPSocketOptions>::Convert(*this);
  }


  DirectUDPSocketOptions();

  DirectUDPSocketOptions(
      const absl::optional<::net::HostPortPair>& remote_addr,
      const absl::optional<::net::IPEndPoint>& local_addr,
      int32_t send_buffer_size,
      int32_t receive_buffer_size,
      ::net::DnsQueryType dns_query_type);


  ~DirectUDPSocketOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DirectUDPSocketOptionsPtr>
  DirectUDPSocketOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DirectUDPSocketOptions::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, DirectUDPSocketOptions::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DirectUDPSocketOptions::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DirectUDPSocketOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DirectUDPSocketOptions_UnserializedMessageContext<
            UserType, DirectUDPSocketOptions::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<DirectUDPSocketOptions::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return DirectUDPSocketOptions::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DirectUDPSocketOptions_UnserializedMessageContext<
            UserType, DirectUDPSocketOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DirectUDPSocketOptions::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  absl::optional<::net::HostPortPair> remote_addr;
  
  absl::optional<::net::IPEndPoint> local_addr;
  
  int32_t send_buffer_size;
  
  int32_t receive_buffer_size;
  
  ::net::DnsQueryType dns_query_type;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DirectUDPSocketOptions::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DirectUDPSocketOptions::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DirectUDPSocketOptions::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DirectUDPSocketOptions::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT DirectTCPServerSocketOptions {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DirectTCPServerSocketOptions, T>::value>;
  using DataView = DirectTCPServerSocketOptionsDataView;
  using Data_ = internal::DirectTCPServerSocketOptions_Data;

  template <typename... Args>
  static DirectTCPServerSocketOptionsPtr New(Args&&... args) {
    return DirectTCPServerSocketOptionsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DirectTCPServerSocketOptionsPtr From(const U& u) {
    return mojo::TypeConverter<DirectTCPServerSocketOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DirectTCPServerSocketOptions>::Convert(*this);
  }


  DirectTCPServerSocketOptions();

  DirectTCPServerSocketOptions(
      const ::net::IPEndPoint& local_addr,
      uint32_t backlog);


  ~DirectTCPServerSocketOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DirectTCPServerSocketOptionsPtr>
  DirectTCPServerSocketOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DirectTCPServerSocketOptions::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, DirectTCPServerSocketOptions::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DirectTCPServerSocketOptions::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DirectTCPServerSocketOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DirectTCPServerSocketOptions_UnserializedMessageContext<
            UserType, DirectTCPServerSocketOptions::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<DirectTCPServerSocketOptions::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return DirectTCPServerSocketOptions::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DirectTCPServerSocketOptions_UnserializedMessageContext<
            UserType, DirectTCPServerSocketOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DirectTCPServerSocketOptions::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::net::IPEndPoint local_addr;
  
  uint32_t backlog;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DirectTCPServerSocketOptions::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DirectTCPServerSocketOptions::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DirectTCPServerSocketOptions::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DirectTCPServerSocketOptions::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
DirectTCPSocketOptionsPtr DirectTCPSocketOptions::Clone() const {
  return New(
      mojo::Clone(remote_addr),
      mojo::Clone(local_addr),
      mojo::Clone(send_buffer_size),
      mojo::Clone(receive_buffer_size),
      mojo::Clone(no_delay),
      mojo::Clone(keep_alive_options),
      mojo::Clone(dns_query_type)
  );
}

template <typename T, DirectTCPSocketOptions::EnableIfSame<T>*>
bool DirectTCPSocketOptions::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->remote_addr, other_struct.remote_addr))
    return false;
  if (!mojo::Equals(this->local_addr, other_struct.local_addr))
    return false;
  if (!mojo::Equals(this->send_buffer_size, other_struct.send_buffer_size))
    return false;
  if (!mojo::Equals(this->receive_buffer_size, other_struct.receive_buffer_size))
    return false;
  if (!mojo::Equals(this->no_delay, other_struct.no_delay))
    return false;
  if (!mojo::Equals(this->keep_alive_options, other_struct.keep_alive_options))
    return false;
  if (!mojo::Equals(this->dns_query_type, other_struct.dns_query_type))
    return false;
  return true;
}

template <typename T, DirectTCPSocketOptions::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.remote_addr < rhs.remote_addr)
    return true;
  if (rhs.remote_addr < lhs.remote_addr)
    return false;
  if (lhs.local_addr < rhs.local_addr)
    return true;
  if (rhs.local_addr < lhs.local_addr)
    return false;
  if (lhs.send_buffer_size < rhs.send_buffer_size)
    return true;
  if (rhs.send_buffer_size < lhs.send_buffer_size)
    return false;
  if (lhs.receive_buffer_size < rhs.receive_buffer_size)
    return true;
  if (rhs.receive_buffer_size < lhs.receive_buffer_size)
    return false;
  if (lhs.no_delay < rhs.no_delay)
    return true;
  if (rhs.no_delay < lhs.no_delay)
    return false;
  if (lhs.keep_alive_options < rhs.keep_alive_options)
    return true;
  if (rhs.keep_alive_options < lhs.keep_alive_options)
    return false;
  if (lhs.dns_query_type < rhs.dns_query_type)
    return true;
  if (rhs.dns_query_type < lhs.dns_query_type)
    return false;
  return false;
}
template <typename StructPtrType>
DirectUDPSocketOptionsPtr DirectUDPSocketOptions::Clone() const {
  return New(
      mojo::Clone(remote_addr),
      mojo::Clone(local_addr),
      mojo::Clone(send_buffer_size),
      mojo::Clone(receive_buffer_size),
      mojo::Clone(dns_query_type)
  );
}

template <typename T, DirectUDPSocketOptions::EnableIfSame<T>*>
bool DirectUDPSocketOptions::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->remote_addr, other_struct.remote_addr))
    return false;
  if (!mojo::Equals(this->local_addr, other_struct.local_addr))
    return false;
  if (!mojo::Equals(this->send_buffer_size, other_struct.send_buffer_size))
    return false;
  if (!mojo::Equals(this->receive_buffer_size, other_struct.receive_buffer_size))
    return false;
  if (!mojo::Equals(this->dns_query_type, other_struct.dns_query_type))
    return false;
  return true;
}

template <typename T, DirectUDPSocketOptions::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.remote_addr < rhs.remote_addr)
    return true;
  if (rhs.remote_addr < lhs.remote_addr)
    return false;
  if (lhs.local_addr < rhs.local_addr)
    return true;
  if (rhs.local_addr < lhs.local_addr)
    return false;
  if (lhs.send_buffer_size < rhs.send_buffer_size)
    return true;
  if (rhs.send_buffer_size < lhs.send_buffer_size)
    return false;
  if (lhs.receive_buffer_size < rhs.receive_buffer_size)
    return true;
  if (rhs.receive_buffer_size < lhs.receive_buffer_size)
    return false;
  if (lhs.dns_query_type < rhs.dns_query_type)
    return true;
  if (rhs.dns_query_type < lhs.dns_query_type)
    return false;
  return false;
}
template <typename StructPtrType>
DirectTCPServerSocketOptionsPtr DirectTCPServerSocketOptions::Clone() const {
  return New(
      mojo::Clone(local_addr),
      mojo::Clone(backlog)
  );
}

template <typename T, DirectTCPServerSocketOptions::EnableIfSame<T>*>
bool DirectTCPServerSocketOptions::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->local_addr, other_struct.local_addr))
    return false;
  if (!mojo::Equals(this->backlog, other_struct.backlog))
    return false;
  return true;
}

template <typename T, DirectTCPServerSocketOptions::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.local_addr < rhs.local_addr)
    return true;
  if (rhs.local_addr < lhs.local_addr)
    return false;
  if (lhs.backlog < rhs.backlog)
    return true;
  if (rhs.backlog < lhs.backlog)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::DirectTCPSocketOptions::DataView,
                                         ::blink::mojom::DirectTCPSocketOptionsPtr> {
  static bool IsNull(const ::blink::mojom::DirectTCPSocketOptionsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::DirectTCPSocketOptionsPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::DirectTCPSocketOptions::remote_addr)& remote_addr(
      const ::blink::mojom::DirectTCPSocketOptionsPtr& input) {
    return input->remote_addr;
  }

  static const decltype(::blink::mojom::DirectTCPSocketOptions::local_addr)& local_addr(
      const ::blink::mojom::DirectTCPSocketOptionsPtr& input) {
    return input->local_addr;
  }

  static decltype(::blink::mojom::DirectTCPSocketOptions::send_buffer_size) send_buffer_size(
      const ::blink::mojom::DirectTCPSocketOptionsPtr& input) {
    return input->send_buffer_size;
  }

  static decltype(::blink::mojom::DirectTCPSocketOptions::receive_buffer_size) receive_buffer_size(
      const ::blink::mojom::DirectTCPSocketOptionsPtr& input) {
    return input->receive_buffer_size;
  }

  static decltype(::blink::mojom::DirectTCPSocketOptions::no_delay) no_delay(
      const ::blink::mojom::DirectTCPSocketOptionsPtr& input) {
    return input->no_delay;
  }

  static const decltype(::blink::mojom::DirectTCPSocketOptions::keep_alive_options)& keep_alive_options(
      const ::blink::mojom::DirectTCPSocketOptionsPtr& input) {
    return input->keep_alive_options;
  }

  static decltype(::blink::mojom::DirectTCPSocketOptions::dns_query_type) dns_query_type(
      const ::blink::mojom::DirectTCPSocketOptionsPtr& input) {
    return input->dns_query_type;
  }

  static bool Read(::blink::mojom::DirectTCPSocketOptions::DataView input, ::blink::mojom::DirectTCPSocketOptionsPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::DirectUDPSocketOptions::DataView,
                                         ::blink::mojom::DirectUDPSocketOptionsPtr> {
  static bool IsNull(const ::blink::mojom::DirectUDPSocketOptionsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::DirectUDPSocketOptionsPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::DirectUDPSocketOptions::remote_addr)& remote_addr(
      const ::blink::mojom::DirectUDPSocketOptionsPtr& input) {
    return input->remote_addr;
  }

  static const decltype(::blink::mojom::DirectUDPSocketOptions::local_addr)& local_addr(
      const ::blink::mojom::DirectUDPSocketOptionsPtr& input) {
    return input->local_addr;
  }

  static decltype(::blink::mojom::DirectUDPSocketOptions::send_buffer_size) send_buffer_size(
      const ::blink::mojom::DirectUDPSocketOptionsPtr& input) {
    return input->send_buffer_size;
  }

  static decltype(::blink::mojom::DirectUDPSocketOptions::receive_buffer_size) receive_buffer_size(
      const ::blink::mojom::DirectUDPSocketOptionsPtr& input) {
    return input->receive_buffer_size;
  }

  static decltype(::blink::mojom::DirectUDPSocketOptions::dns_query_type) dns_query_type(
      const ::blink::mojom::DirectUDPSocketOptionsPtr& input) {
    return input->dns_query_type;
  }

  static bool Read(::blink::mojom::DirectUDPSocketOptions::DataView input, ::blink::mojom::DirectUDPSocketOptionsPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::DirectTCPServerSocketOptions::DataView,
                                         ::blink::mojom::DirectTCPServerSocketOptionsPtr> {
  static bool IsNull(const ::blink::mojom::DirectTCPServerSocketOptionsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::DirectTCPServerSocketOptionsPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::DirectTCPServerSocketOptions::local_addr)& local_addr(
      const ::blink::mojom::DirectTCPServerSocketOptionsPtr& input) {
    return input->local_addr;
  }

  static decltype(::blink::mojom::DirectTCPServerSocketOptions::backlog) backlog(
      const ::blink::mojom::DirectTCPServerSocketOptionsPtr& input) {
    return input->backlog;
  }

  static bool Read(::blink::mojom::DirectTCPServerSocketOptions::DataView input, ::blink::mojom::DirectTCPServerSocketOptionsPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_DIRECT_SOCKETS_DIRECT_SOCKETS_MOJOM_H_