// third_party/blink/public/mojom/frame/view_transition_state.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_VIEW_TRANSITION_STATE_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_VIEW_TRANSITION_STATE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/frame/view_transition_state.mojom-shared-internal.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-shared.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-shared.h"
#include "ui/gfx/mojom/transform.mojom-shared.h"
#include "services/viz/public/mojom/compositing/view_transition_element_resource_id.mojom-shared.h"



#include "base/component_export.h"




namespace blink {
namespace mojom {
class ViewTransitionElementDataView;

class ViewTransitionStateDataView;



}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::ViewTransitionElementDataView> {
  using Data = ::blink::mojom::internal::ViewTransitionElement_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::blink::mojom::ViewTransitionStateDataView> {
  using Data = ::blink::mojom::internal::ViewTransitionState_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {


class ViewTransitionElementDataView {
 public:
  ViewTransitionElementDataView() = default;

  ViewTransitionElementDataView(
      internal::ViewTransitionElement_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetTagNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadTagName(UserType* output) {
    
    auto* pointer = data_->tag_name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetBorderBoxSizeInCssSpaceDataView(
      ::gfx::mojom::SizeFDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadBorderBoxSizeInCssSpace(UserType* output) {
    
    auto* pointer = data_->border_box_size_in_css_space.Get();
    return mojo::internal::Deserialize<::gfx::mojom::SizeFDataView>(
        pointer, output, message_);
  }
  inline void GetViewportMatrixDataView(
      ::gfx::mojom::TransformDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadViewportMatrix(UserType* output) {
    
    auto* pointer = data_->viewport_matrix.Get();
    return mojo::internal::Deserialize<::gfx::mojom::TransformDataView>(
        pointer, output, message_);
  }
  inline void GetOverflowRectInLayoutSpaceDataView(
      ::gfx::mojom::RectFDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadOverflowRectInLayoutSpace(UserType* output) {
    
    auto* pointer = data_->overflow_rect_in_layout_space.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RectFDataView>(
        pointer, output, message_);
  }
  inline void GetSnapshotIdDataView(
      ::viz::mojom::ViewTransitionElementResourceIdDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadSnapshotId(UserType* output) {
    
    auto* pointer = data_->snapshot_id.Get();
    return mojo::internal::Deserialize<::viz::mojom::ViewTransitionElementResourceIdDataView>(
        pointer, output, message_);
  }
  int32_t paint_order() const {
    return data_->paint_order;
  }
  bool is_root() const {
    return data_->is_root;
  }
 private:
  internal::ViewTransitionElement_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



class ViewTransitionStateDataView {
 public:
  ViewTransitionStateDataView() = default;

  ViewTransitionStateDataView(
      internal::ViewTransitionState_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetElementsDataView(
      mojo::ArrayDataView<ViewTransitionElementDataView>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadElements(UserType* output) {
    
    auto* pointer = data_->elements.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::blink::mojom::ViewTransitionElementDataView>>(
        pointer, output, message_);
  }
  inline void GetNavigationIdDataView(
      ::mojo_base::mojom::UnguessableTokenDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadNavigationId(UserType* output) {
    
    auto* pointer = data_->navigation_id.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::UnguessableTokenDataView>(
        pointer, output, message_);
  }
 private:
  internal::ViewTransitionState_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::ViewTransitionElementDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::ViewTransitionElementDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::ViewTransitionElement_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::tag_name(input)) in_tag_name = Traits::tag_name(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->tag_name)::BaseType> tag_name_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_tag_name, tag_name_fragment);
    fragment->tag_name.Set(
        tag_name_fragment.is_null() ? nullptr : tag_name_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->tag_name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null tag_name in ViewTransitionElement struct");
    decltype(Traits::border_box_size_in_css_space(input)) in_border_box_size_in_css_space = Traits::border_box_size_in_css_space(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->border_box_size_in_css_space)::BaseType> border_box_size_in_css_space_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::SizeFDataView>(
        in_border_box_size_in_css_space, border_box_size_in_css_space_fragment);
    fragment->border_box_size_in_css_space.Set(
        border_box_size_in_css_space_fragment.is_null() ? nullptr : border_box_size_in_css_space_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->border_box_size_in_css_space.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null border_box_size_in_css_space in ViewTransitionElement struct");
    decltype(Traits::viewport_matrix(input)) in_viewport_matrix = Traits::viewport_matrix(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->viewport_matrix)::BaseType> viewport_matrix_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::TransformDataView>(
        in_viewport_matrix, viewport_matrix_fragment);
    fragment->viewport_matrix.Set(
        viewport_matrix_fragment.is_null() ? nullptr : viewport_matrix_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->viewport_matrix.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null viewport_matrix in ViewTransitionElement struct");
    decltype(Traits::overflow_rect_in_layout_space(input)) in_overflow_rect_in_layout_space = Traits::overflow_rect_in_layout_space(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->overflow_rect_in_layout_space)::BaseType> overflow_rect_in_layout_space_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::RectFDataView>(
        in_overflow_rect_in_layout_space, overflow_rect_in_layout_space_fragment);
    fragment->overflow_rect_in_layout_space.Set(
        overflow_rect_in_layout_space_fragment.is_null() ? nullptr : overflow_rect_in_layout_space_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->overflow_rect_in_layout_space.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null overflow_rect_in_layout_space in ViewTransitionElement struct");
    decltype(Traits::snapshot_id(input)) in_snapshot_id = Traits::snapshot_id(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->snapshot_id)::BaseType> snapshot_id_fragment(
            fragment.message());
    mojo::internal::Serialize<::viz::mojom::ViewTransitionElementResourceIdDataView>(
        in_snapshot_id, snapshot_id_fragment);
    fragment->snapshot_id.Set(
        snapshot_id_fragment.is_null() ? nullptr : snapshot_id_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->snapshot_id.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null snapshot_id in ViewTransitionElement struct");
    fragment->paint_order = Traits::paint_order(input);
    fragment->is_root = Traits::is_root(input);
  }

  static bool Deserialize(::blink::mojom::internal::ViewTransitionElement_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::ViewTransitionElementDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::ViewTransitionStateDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::ViewTransitionStateDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::ViewTransitionState_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::elements(input)) in_elements = Traits::elements(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->elements)::BaseType>
        elements_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& elements_validate_params =
        mojo::internal::GetArrayValidator<0, false, nullptr>();
    mojo::internal::Serialize<mojo::ArrayDataView<::blink::mojom::ViewTransitionElementDataView>>(
        in_elements, elements_fragment, &elements_validate_params);
    fragment->elements.Set(
        elements_fragment.is_null() ? nullptr : elements_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->elements.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null elements in ViewTransitionState struct");
    decltype(Traits::navigation_id(input)) in_navigation_id = Traits::navigation_id(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->navigation_id)::BaseType> navigation_id_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::UnguessableTokenDataView>(
        in_navigation_id, navigation_id_fragment);
    fragment->navigation_id.Set(
        navigation_id_fragment.is_null() ? nullptr : navigation_id_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->navigation_id.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null navigation_id in ViewTransitionState struct");
  }

  static bool Deserialize(::blink::mojom::internal::ViewTransitionState_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::ViewTransitionStateDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {

inline void ViewTransitionElementDataView::GetTagNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->tag_name.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void ViewTransitionElementDataView::GetBorderBoxSizeInCssSpaceDataView(
    ::gfx::mojom::SizeFDataView* output) {
  auto pointer = data_->border_box_size_in_css_space.Get();
  *output = ::gfx::mojom::SizeFDataView(pointer, message_);
}
inline void ViewTransitionElementDataView::GetViewportMatrixDataView(
    ::gfx::mojom::TransformDataView* output) {
  auto pointer = data_->viewport_matrix.Get();
  *output = ::gfx::mojom::TransformDataView(pointer, message_);
}
inline void ViewTransitionElementDataView::GetOverflowRectInLayoutSpaceDataView(
    ::gfx::mojom::RectFDataView* output) {
  auto pointer = data_->overflow_rect_in_layout_space.Get();
  *output = ::gfx::mojom::RectFDataView(pointer, message_);
}
inline void ViewTransitionElementDataView::GetSnapshotIdDataView(
    ::viz::mojom::ViewTransitionElementResourceIdDataView* output) {
  auto pointer = data_->snapshot_id.Get();
  *output = ::viz::mojom::ViewTransitionElementResourceIdDataView(pointer, message_);
}


inline void ViewTransitionStateDataView::GetElementsDataView(
    mojo::ArrayDataView<ViewTransitionElementDataView>* output) {
  auto pointer = data_->elements.Get();
  *output = mojo::ArrayDataView<ViewTransitionElementDataView>(pointer, message_);
}
inline void ViewTransitionStateDataView::GetNavigationIdDataView(
    ::mojo_base::mojom::UnguessableTokenDataView* output) {
  auto pointer = data_->navigation_id.Get();
  *output = ::mojo_base::mojom::UnguessableTokenDataView(pointer, message_);
}



}  // namespace mojom
}  // namespace blink

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_VIEW_TRANSITION_STATE_MOJOM_SHARED_H_