// third_party/blink/public/mojom/interest_group/ad_auction_service.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_INTEREST_GROUP_AD_AUCTION_SERVICE_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_INTEREST_GROUP_AD_AUCTION_SERVICE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/interest_group/ad_auction_service.mojom-shared.h"
#include "third_party/blink/public/mojom/interest_group/ad_auction_service.mojom-forward.h"
#include "third_party/blink/public/mojom/fenced_frame/fenced_frame_config.mojom.h"
#include "third_party/blink/public/mojom/parakeet/ad_request.mojom-forward.h"
#include "third_party/blink/public/mojom/interest_group/interest_group_types.mojom.h"
#include "mojo/public/mojom/base/time.mojom-forward.h"
#include "url/mojom/origin.mojom.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink {
namespace mojom {

class AbortableAdAuctionProxy;

template <typename ImplRefTraits>
class AbortableAdAuctionStub;

class AbortableAdAuctionRequestValidator;


class BLINK_COMMON_EXPORT AbortableAdAuction
    : public AbortableAdAuctionInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = AbortableAdAuctionInterfaceBase;
  using Proxy_ = AbortableAdAuctionProxy;

  template <typename ImplRefTraits>
  using Stub_ = AbortableAdAuctionStub<ImplRefTraits>;

  using RequestValidator_ = AbortableAdAuctionRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kResolvedPromiseParamMinVersion = 0,
    kResolvedPerBuyerSignalsPromiseMinVersion = 0,
    kResolvedBuyerTimeoutsPromiseMinVersion = 0,
    kResolvedDirectFromSellerSignalsPromiseMinVersion = 0,
    kAbortMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct ResolvedPromiseParam_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct ResolvedPerBuyerSignalsPromise_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct ResolvedBuyerTimeoutsPromise_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct ResolvedDirectFromSellerSignalsPromise_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct Abort_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~AbortableAdAuction() = default;

  
  virtual void ResolvedPromiseParam(AuctionAdConfigAuctionIdPtr auction, AuctionAdConfigField field, const absl::optional<std::string>& json_value) = 0;

  
  virtual void ResolvedPerBuyerSignalsPromise(AuctionAdConfigAuctionIdPtr auction, const absl::optional<base::flat_map<::url::Origin, std::string>>& per_buyer_signals) = 0;

  
  virtual void ResolvedBuyerTimeoutsPromise(AuctionAdConfigAuctionIdPtr auction, AuctionAdConfigBuyerTimeoutField field, const ::blink::AuctionConfig::BuyerTimeouts& buyer_timeouts) = 0;

  
  virtual void ResolvedDirectFromSellerSignalsPromise(AuctionAdConfigAuctionIdPtr auction, const absl::optional<::blink::DirectFromSellerSignals>& direct_from_seller_signals) = 0;

  
  virtual void Abort() = 0;
};

class AdAuctionServiceProxy;

template <typename ImplRefTraits>
class AdAuctionServiceStub;

class AdAuctionServiceRequestValidator;
class AdAuctionServiceResponseValidator;


class BLINK_COMMON_EXPORT AdAuctionService
    : public AdAuctionServiceInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = AdAuctionServiceInterfaceBase;
  using Proxy_ = AdAuctionServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = AdAuctionServiceStub<ImplRefTraits>;

  using RequestValidator_ = AdAuctionServiceRequestValidator;
  using ResponseValidator_ = AdAuctionServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCreateAdRequestMinVersion = 0,
    kFinalizeAdMinVersion = 0,
    kRunAdAuctionMinVersion = 0,
    kJoinInterestGroupMinVersion = 0,
    kLeaveInterestGroupMinVersion = 0,
    kLeaveInterestGroupForDocumentMinVersion = 0,
    kUpdateAdInterestGroupsMinVersion = 0,
    kDeprecatedGetURLFromURNMinVersion = 0,
    kDeprecatedReplaceInURNMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct CreateAdRequest_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct FinalizeAd_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct RunAdAuction_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct JoinInterestGroup_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct LeaveInterestGroup_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct LeaveInterestGroupForDocument_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct UpdateAdInterestGroups_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct DeprecatedGetURLFromURN_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct DeprecatedReplaceInURN_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~AdAuctionService() = default;


  using CreateAdRequestCallback = base::OnceCallback<void(const absl::optional<std::string>&)>;
  
  virtual void CreateAdRequest(::blink::mojom::AdRequestConfigPtr config, CreateAdRequestCallback callback) = 0;


  using FinalizeAdCallback = base::OnceCallback<void(const absl::optional<::GURL>&)>;
  
  virtual void FinalizeAd(const std::string& ads_guid, const ::blink::AuctionConfig& config, FinalizeAdCallback callback) = 0;


  using RunAdAuctionCallback = base::OnceCallback<void(bool, const absl::optional<::blink::FencedFrame::RedactedFencedFrameConfig>&)>;
  
  virtual void RunAdAuction(const ::blink::AuctionConfig& config, ::mojo::PendingReceiver<AbortableAdAuction> abort_receiver, RunAdAuctionCallback callback) = 0;


  using JoinInterestGroupCallback = base::OnceCallback<void(bool)>;
  
  virtual void JoinInterestGroup(const ::blink::InterestGroup& group, JoinInterestGroupCallback callback) = 0;


  using LeaveInterestGroupCallback = base::OnceCallback<void(bool)>;
  
  virtual void LeaveInterestGroup(const ::url::Origin& owner, const std::string& name, LeaveInterestGroupCallback callback) = 0;

  
  virtual void LeaveInterestGroupForDocument() = 0;

  
  virtual void UpdateAdInterestGroups() = 0;


  using DeprecatedGetURLFromURNCallback = base::OnceCallback<void(const absl::optional<::GURL>&)>;
  
  virtual void DeprecatedGetURLFromURN(const ::GURL& uuid_url, bool send_reports, DeprecatedGetURLFromURNCallback callback) = 0;


  using DeprecatedReplaceInURNCallback = base::OnceCallback<void()>;
  
  virtual void DeprecatedReplaceInURN(const ::GURL& uuid_url, std::vector<AdKeywordReplacementPtr> replacements, DeprecatedReplaceInURNCallback callback) = 0;
};



class BLINK_COMMON_EXPORT AbortableAdAuctionProxy
    : public AbortableAdAuction {
 public:
  using InterfaceType = AbortableAdAuction;

  explicit AbortableAdAuctionProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void ResolvedPromiseParam(AuctionAdConfigAuctionIdPtr auction, AuctionAdConfigField field, const absl::optional<std::string>& json_value) final;
  
  void ResolvedPerBuyerSignalsPromise(AuctionAdConfigAuctionIdPtr auction, const absl::optional<base::flat_map<::url::Origin, std::string>>& per_buyer_signals) final;
  
  void ResolvedBuyerTimeoutsPromise(AuctionAdConfigAuctionIdPtr auction, AuctionAdConfigBuyerTimeoutField field, const ::blink::AuctionConfig::BuyerTimeouts& buyer_timeouts) final;
  
  void ResolvedDirectFromSellerSignalsPromise(AuctionAdConfigAuctionIdPtr auction, const absl::optional<::blink::DirectFromSellerSignals>& direct_from_seller_signals) final;
  
  void Abort() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class BLINK_COMMON_EXPORT AdAuctionServiceProxy
    : public AdAuctionService {
 public:
  using InterfaceType = AdAuctionService;

  explicit AdAuctionServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreateAdRequest(::blink::mojom::AdRequestConfigPtr config, CreateAdRequestCallback callback) final;
  
  void FinalizeAd(const std::string& ads_guid, const ::blink::AuctionConfig& config, FinalizeAdCallback callback) final;
  
  void RunAdAuction(const ::blink::AuctionConfig& config, ::mojo::PendingReceiver<AbortableAdAuction> abort_receiver, RunAdAuctionCallback callback) final;
  
  void JoinInterestGroup(const ::blink::InterestGroup& group, JoinInterestGroupCallback callback) final;
  
  void LeaveInterestGroup(const ::url::Origin& owner, const std::string& name, LeaveInterestGroupCallback callback) final;
  
  void LeaveInterestGroupForDocument() final;
  
  void UpdateAdInterestGroups() final;
  
  void DeprecatedGetURLFromURN(const ::GURL& uuid_url, bool send_reports, DeprecatedGetURLFromURNCallback callback) final;
  
  void DeprecatedReplaceInURN(const ::GURL& uuid_url, std::vector<AdKeywordReplacementPtr> replacements, DeprecatedReplaceInURNCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT AbortableAdAuctionStubDispatch {
 public:
  static bool Accept(AbortableAdAuction* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      AbortableAdAuction* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<AbortableAdAuction>>
class AbortableAdAuctionStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  AbortableAdAuctionStub() = default;
  ~AbortableAdAuctionStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AbortableAdAuctionStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AbortableAdAuctionStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT AdAuctionServiceStubDispatch {
 public:
  static bool Accept(AdAuctionService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      AdAuctionService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<AdAuctionService>>
class AdAuctionServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  AdAuctionServiceStub() = default;
  ~AdAuctionServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AdAuctionServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AdAuctionServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT AbortableAdAuctionRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT AdAuctionServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT AdAuctionServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class BLINK_COMMON_EXPORT AdKeywordReplacement {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AdKeywordReplacement, T>::value>;
  using DataView = AdKeywordReplacementDataView;
  using Data_ = internal::AdKeywordReplacement_Data;

  template <typename... Args>
  static AdKeywordReplacementPtr New(Args&&... args) {
    return AdKeywordReplacementPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AdKeywordReplacementPtr From(const U& u) {
    return mojo::TypeConverter<AdKeywordReplacementPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AdKeywordReplacement>::Convert(*this);
  }


  AdKeywordReplacement();

  AdKeywordReplacement(
      const std::string& match,
      const std::string& replacement);


  ~AdKeywordReplacement();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AdKeywordReplacementPtr>
  AdKeywordReplacementPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AdKeywordReplacement::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AdKeywordReplacement::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AdKeywordReplacement::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AdKeywordReplacement::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AdKeywordReplacement_UnserializedMessageContext<
            UserType, AdKeywordReplacement::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AdKeywordReplacement::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return AdKeywordReplacement::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AdKeywordReplacement_UnserializedMessageContext<
            UserType, AdKeywordReplacement::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AdKeywordReplacement::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string match;
  
  std::string replacement;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AdKeywordReplacement::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AdKeywordReplacement::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AdKeywordReplacement::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AdKeywordReplacement::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT AuctionAdConfigAuctionId {
 public:
  using DataView = AuctionAdConfigAuctionIdDataView;
  using Data_ = internal::AuctionAdConfigAuctionId_Data;
  using Tag = Data_::AuctionAdConfigAuctionId_Tag;

  template <typename... Args>
  static AuctionAdConfigAuctionIdPtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |main_auction|.
  static AuctionAdConfigAuctionIdPtr
  NewMainAuction(
      uint32_t main_auction) {
    auto result = AuctionAdConfigAuctionIdPtr(absl::in_place);
    result->set_main_auction(std::move(main_auction));
    return result;
  }
  // Construct an instance holding |component_auction|.
  static AuctionAdConfigAuctionIdPtr
  NewComponentAuction(
      uint32_t component_auction) {
    auto result = AuctionAdConfigAuctionIdPtr(absl::in_place);
    result->set_component_auction(std::move(component_auction));
    return result;
  }

  template <typename U>
  static AuctionAdConfigAuctionIdPtr From(const U& u) {
    return mojo::TypeConverter<AuctionAdConfigAuctionIdPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AuctionAdConfigAuctionId>::Convert(*this);
  }

  AuctionAdConfigAuctionId();
  ~AuctionAdConfigAuctionId();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = AuctionAdConfigAuctionIdPtr>
  AuctionAdConfigAuctionIdPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, AuctionAdConfigAuctionId>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, AuctionAdConfigAuctionId>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  size_t Hash(size_t seed) const;

  Tag which() const {
    return tag_;
  }


  
  bool is_main_auction() const { return tag_ == Tag::kMainAuction; }

  
  uint32_t get_main_auction() const {
    CHECK(tag_ == Tag::kMainAuction);
    return data_.main_auction;
  }

  
  void set_main_auction(
      uint32_t main_auction);
  
  bool is_component_auction() const { return tag_ == Tag::kComponentAuction; }

  
  uint32_t get_component_auction() const {
    CHECK(tag_ == Tag::kComponentAuction);
    return data_.component_auction;
  }

  
  void set_component_auction(
      uint32_t component_auction);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AuctionAdConfigAuctionId::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<AuctionAdConfigAuctionId::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    uint32_t main_auction;
    uint32_t component_auction;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};


template <typename UnionPtrType>
AuctionAdConfigAuctionIdPtr AuctionAdConfigAuctionId::Clone() const {
  switch (tag_) {
    case Tag::kMainAuction:
      return NewMainAuction(
          mojo::Clone(data_.main_auction));
    case Tag::kComponentAuction:
      return NewComponentAuction(
          mojo::Clone(data_.component_auction));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, AuctionAdConfigAuctionId>::value>::type*>
bool AuctionAdConfigAuctionId::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kMainAuction:
      return mojo::Equals(data_.main_auction, other.data_.main_auction);
    case Tag::kComponentAuction:
      return mojo::Equals(data_.component_auction, other.data_.component_auction);
  }

  return false;
}
template <typename StructPtrType>
AdKeywordReplacementPtr AdKeywordReplacement::Clone() const {
  return New(
      mojo::Clone(match),
      mojo::Clone(replacement)
  );
}

template <typename T, AdKeywordReplacement::EnableIfSame<T>*>
bool AdKeywordReplacement::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->match, other_struct.match))
    return false;
  if (!mojo::Equals(this->replacement, other_struct.replacement))
    return false;
  return true;
}

template <typename T, AdKeywordReplacement::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.match < rhs.match)
    return true;
  if (rhs.match < lhs.match)
    return false;
  if (lhs.replacement < rhs.replacement)
    return true;
  if (rhs.replacement < lhs.replacement)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AdKeywordReplacement::DataView,
                                         ::blink::mojom::AdKeywordReplacementPtr> {
  static bool IsNull(const ::blink::mojom::AdKeywordReplacementPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AdKeywordReplacementPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::AdKeywordReplacement::match)& match(
      const ::blink::mojom::AdKeywordReplacementPtr& input) {
    return input->match;
  }

  static const decltype(::blink::mojom::AdKeywordReplacement::replacement)& replacement(
      const ::blink::mojom::AdKeywordReplacementPtr& input) {
    return input->replacement;
  }

  static bool Read(::blink::mojom::AdKeywordReplacement::DataView input, ::blink::mojom::AdKeywordReplacementPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT UnionTraits<::blink::mojom::AuctionAdConfigAuctionId::DataView,
                                        ::blink::mojom::AuctionAdConfigAuctionIdPtr> {
  static bool IsNull(const ::blink::mojom::AuctionAdConfigAuctionIdPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AuctionAdConfigAuctionIdPtr* output) { output->reset(); }

  static ::blink::mojom::AuctionAdConfigAuctionId::Tag GetTag(const ::blink::mojom::AuctionAdConfigAuctionIdPtr& input) {
    return input->which();
  }

  static  uint32_t main_auction(const ::blink::mojom::AuctionAdConfigAuctionIdPtr& input) {
    return input->get_main_auction();
  }

  static  uint32_t component_auction(const ::blink::mojom::AuctionAdConfigAuctionIdPtr& input) {
    return input->get_component_auction();
  }

  static bool Read(::blink::mojom::AuctionAdConfigAuctionId::DataView input, ::blink::mojom::AuctionAdConfigAuctionIdPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_INTEREST_GROUP_AD_AUCTION_SERVICE_MOJOM_H_