// third_party/blink/public/mojom/portal/portal.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/portal/portal.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/portal/portal.mojom-params-data.h"
namespace blink {
namespace mojom {

static NOINLINE const char* PortalActivateResultToStringHelper(PortalActivateResult value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case PortalActivateResult::kPredecessorWillUnload:
      return "kPredecessorWillUnload";
    case PortalActivateResult::kPredecessorWasAdopted:
      return "kPredecessorWasAdopted";
    case PortalActivateResult::kRejectedDueToPortalNotReady:
      return "kRejectedDueToPortalNotReady";
    case PortalActivateResult::kRejectedDueToErrorInPortal:
      return "kRejectedDueToErrorInPortal";
    case PortalActivateResult::kRejectedDueToPredecessorNavigation:
      return "kRejectedDueToPredecessorNavigation";
    case PortalActivateResult::kDisconnected:
      return "kDisconnected";
    case PortalActivateResult::kNotImplemented:
      return "kNotImplemented";
    case PortalActivateResult::kAbortedDueToBug:
      return "kAbortedDueToBug";
    default:
      return nullptr;
  }
}

std::string PortalActivateResultToString(PortalActivateResult value) {
  const char *str = PortalActivateResultToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown PortalActivateResult value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, PortalActivateResult value) {
  return os << PortalActivateResultToString(value);
}

namespace internal {


// static
bool Portal_Navigate_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Portal_Navigate_Params_Data* object =
      static_cast<const Portal_Navigate_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->url, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->url, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->referrer, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->referrer, validation_context))
    return false;

  return true;
}

Portal_Navigate_Params_Data::Portal_Navigate_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Portal_Navigate_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Portal_Navigate_ResponseParams_Data* object =
      static_cast<const Portal_Navigate_ResponseParams_Data*>(data);

  return true;
}

Portal_Navigate_ResponseParams_Data::Portal_Navigate_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Portal_Activate_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Portal_Activate_Params_Data* object =
      static_cast<const Portal_Activate_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->data, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->data, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->activation_time, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->activation_time, validation_context))
    return false;

  return true;
}

Portal_Activate_Params_Data::Portal_Activate_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Portal_Activate_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Portal_Activate_ResponseParams_Data* object =
      static_cast<const Portal_Activate_ResponseParams_Data*>(data);


  if (!::blink::mojom::internal::PortalActivateResult_Data
        ::Validate(object->result, validation_context))
    return false;

  return true;
}

Portal_Activate_ResponseParams_Data::Portal_Activate_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Portal_PostMessageToGuest_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Portal_PostMessageToGuest_Params_Data* object =
      static_cast<const Portal_PostMessageToGuest_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->message, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->message, validation_context))
    return false;

  return true;
}

Portal_PostMessageToGuest_Params_Data::Portal_PostMessageToGuest_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PortalClient_ForwardMessageFromGuest_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PortalClient_ForwardMessageFromGuest_Params_Data* object =
      static_cast<const PortalClient_ForwardMessageFromGuest_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->message, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->message, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->source_origin, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->source_origin, validation_context))
    return false;

  return true;
}

PortalClient_ForwardMessageFromGuest_Params_Data::PortalClient_ForwardMessageFromGuest_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PortalClient_DispatchLoadEvent_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PortalClient_DispatchLoadEvent_Params_Data* object =
      static_cast<const PortalClient_DispatchLoadEvent_Params_Data*>(data);

  return true;
}

PortalClient_DispatchLoadEvent_Params_Data::PortalClient_DispatchLoadEvent_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PortalHost_PostMessageToHost_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PortalHost_PostMessageToHost_Params_Data* object =
      static_cast<const PortalHost_PostMessageToHost_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->message, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->message, validation_context))
    return false;

  return true;
}

PortalHost_PostMessageToHost_Params_Data::PortalHost_PostMessageToHost_Params_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::PortalActivateResult>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::PortalActivateResult value) {
  return std::move(context).WriteString(::blink::mojom::PortalActivateResultToString(value));
}

} // namespace perfetto