// ui/gfx/mojom/hdr_metadata.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "ui/gfx/mojom/hdr_metadata.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "ui/gfx/mojom/hdr_metadata.mojom-params-data.h"
namespace gfx {
namespace mojom {

static NOINLINE const char* HDRModeToStringHelper(HDRMode value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case HDRMode::kDefault:
      return "kDefault";
    case HDRMode::kExtended:
      return "kExtended";
    default:
      return nullptr;
  }
}

std::string HDRModeToString(HDRMode value) {
  const char *str = HDRModeToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown HDRMode value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, HDRMode value) {
  return os << HDRModeToString(value);
}

namespace internal {


// static
bool ColorVolumeMetadata_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ColorVolumeMetadata_Data* object =
      static_cast<const ColorVolumeMetadata_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->primaries, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->primaries, validation_context))
    return false;

  return true;
}

ColorVolumeMetadata_Data::ColorVolumeMetadata_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool HDRMetadata_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const HDRMetadata_Data* object =
      static_cast<const HDRMetadata_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->color_volume_metadata, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->color_volume_metadata, validation_context))
    return false;

  return true;
}

HDRMetadata_Data::HDRMetadata_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace gfx

namespace perfetto {

// static
void TraceFormatTraits<::gfx::mojom::HDRMode>::WriteIntoTrace(
   perfetto::TracedValue context, ::gfx::mojom::HDRMode value) {
  return std::move(context).WriteString(::gfx::mojom::HDRModeToString(value));
}

} // namespace perfetto