// ui/gfx/mojom/hdr_metadata.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_GFX_MOJOM_HDR_METADATA_MOJOM_SHARED_H_
#define UI_GFX_MOJOM_HDR_METADATA_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "ui/gfx/mojom/hdr_metadata.mojom-shared-internal.h"
#include "skia/public/mojom/skcolorspace_primaries.mojom-shared.h"







namespace gfx {
namespace mojom {
class ColorVolumeMetadataDataView;

class HDRMetadataDataView;



}  // namespace mojom
}  // namespace gfx

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::gfx::mojom::ColorVolumeMetadataDataView> {
  using Data = ::gfx::mojom::internal::ColorVolumeMetadata_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::gfx::mojom::HDRMetadataDataView> {
  using Data = ::gfx::mojom::internal::HDRMetadata_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace gfx {
namespace mojom {


enum class HDRMode : int32_t {
  
  kDefault = 0,
  
  kExtended = 1,
  kMinValue = 0,
  kMaxValue = 1,
};

 std::ostream& operator<<(std::ostream& os, HDRMode value);
inline bool IsKnownEnumValue(HDRMode value) {
  return internal::HDRMode_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


class ColorVolumeMetadataDataView {
 public:
  ColorVolumeMetadataDataView() = default;

  ColorVolumeMetadataDataView(
      internal::ColorVolumeMetadata_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetPrimariesDataView(
      ::skia::mojom::SkColorSpacePrimariesDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadPrimaries(UserType* output) {
    
    auto* pointer = data_->primaries.Get();
    return mojo::internal::Deserialize<::skia::mojom::SkColorSpacePrimariesDataView>(
        pointer, output, message_);
  }
  float luminance_max() const {
    return data_->luminance_max;
  }
  float luminance_min() const {
    return data_->luminance_min;
  }
 private:
  internal::ColorVolumeMetadata_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



class HDRMetadataDataView {
 public:
  HDRMetadataDataView() = default;

  HDRMetadataDataView(
      internal::HDRMetadata_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetColorVolumeMetadataDataView(
      ColorVolumeMetadataDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadColorVolumeMetadata(UserType* output) {
    
    auto* pointer = data_->color_volume_metadata.Get();
    return mojo::internal::Deserialize<::gfx::mojom::ColorVolumeMetadataDataView>(
        pointer, output, message_);
  }
  uint32_t max_content_light_level() const {
    return data_->max_content_light_level;
  }
  uint32_t max_frame_average_light_level() const {
    return data_->max_frame_average_light_level;
  }
 private:
  internal::HDRMetadata_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // namespace mojom
}  // namespace gfx

namespace std {

template <>
struct hash<::gfx::mojom::HDRMode>
    : public mojo::internal::EnumHashImpl<::gfx::mojom::HDRMode> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::gfx::mojom::HDRMode, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::gfx::mojom::HDRMode, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::gfx::mojom::HDRMode>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::gfx::mojom::ColorVolumeMetadataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::gfx::mojom::ColorVolumeMetadataDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::gfx::mojom::internal::ColorVolumeMetadata_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::primaries(input)) in_primaries = Traits::primaries(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->primaries)::BaseType> primaries_fragment(
            fragment.message());
    mojo::internal::Serialize<::skia::mojom::SkColorSpacePrimariesDataView>(
        in_primaries, primaries_fragment);
    fragment->primaries.Set(
        primaries_fragment.is_null() ? nullptr : primaries_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->primaries.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null primaries in ColorVolumeMetadata struct");
    fragment->luminance_max = Traits::luminance_max(input);
    fragment->luminance_min = Traits::luminance_min(input);
  }

  static bool Deserialize(::gfx::mojom::internal::ColorVolumeMetadata_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::gfx::mojom::ColorVolumeMetadataDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::gfx::mojom::HDRMetadataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::gfx::mojom::HDRMetadataDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::gfx::mojom::internal::HDRMetadata_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::color_volume_metadata(input)) in_color_volume_metadata = Traits::color_volume_metadata(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->color_volume_metadata)::BaseType> color_volume_metadata_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::ColorVolumeMetadataDataView>(
        in_color_volume_metadata, color_volume_metadata_fragment);
    fragment->color_volume_metadata.Set(
        color_volume_metadata_fragment.is_null() ? nullptr : color_volume_metadata_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->color_volume_metadata.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null color_volume_metadata in HDRMetadata struct");
    fragment->max_content_light_level = Traits::max_content_light_level(input);
    fragment->max_frame_average_light_level = Traits::max_frame_average_light_level(input);
  }

  static bool Deserialize(::gfx::mojom::internal::HDRMetadata_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::gfx::mojom::HDRMetadataDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace gfx {
namespace mojom {

inline void ColorVolumeMetadataDataView::GetPrimariesDataView(
    ::skia::mojom::SkColorSpacePrimariesDataView* output) {
  auto pointer = data_->primaries.Get();
  *output = ::skia::mojom::SkColorSpacePrimariesDataView(pointer, message_);
}


inline void HDRMetadataDataView::GetColorVolumeMetadataDataView(
    ColorVolumeMetadataDataView* output) {
  auto pointer = data_->color_volume_metadata.Get();
  *output = ColorVolumeMetadataDataView(pointer, message_);
}



}  // namespace mojom
}  // namespace gfx

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct  TraceFormatTraits<::gfx::mojom::HDRMode> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::gfx::mojom::HDRMode value);
};

} // namespace perfetto

#endif  // UI_GFX_MOJOM_HDR_METADATA_MOJOM_SHARED_H_